//### This file created by BYACC 1.8(/Java extension  1.15)
//### Java capabilities added 7 Jan 97, Bob Jamison
//### Updated : 27 Nov 97  -- Bob Jamison, Joe Nieten
//###           01 Jan 98  -- Bob Jamison -- fixed generic semantic constructor
//###           01 Jun 99  -- Bob Jamison -- added Runnable support
//###           06 Aug 00  -- Bob Jamison -- made state variables class-global
//###           03 Jan 01  -- Bob Jamison -- improved flags, tracing
//###           16 May 01  -- Bob Jamison -- added custom stack sizing
//###           04 Mar 02  -- Yuval Oren  -- improved java performance, added options
//###           14 Mar 02  -- Tomas Hurka -- -d support, static initializer workaround
//### Please send bug reports to tom@hukatronic.cz
//### static char yysccsid[] = "@(#)yaccpar	1.8 (Berkeley) 01/20/90";



package com.thoughtworks.qdox.parser.impl;



//#line 2 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
/*
 * Licensed to the Apache Software Foundation (ASF) under one
 * or more contributor license agreements.  See the NOTICE file
 * distributed with this work for additional information
 * regarding copyright ownership.  The ASF licenses this file
 * to you under the Apache License, Version 2.0 (the
 * "License"); you may not use this file except in compliance
 * with the License.  You may obtain a copy of the License at
 *
 *   http://www.apache.org/licenses/LICENSE-2.0
 *
 * Unless required by applicable law or agreed to in writing,
 * software distributed under the License is distributed on an
 * "AS IS" BASIS, WITHOUT WARRANTIES OR CONDITIONS OF ANY
 * KIND, either express or implied.  See the License for the
 * specific language governing permissions and limitations
 * under the License.
 */

import com.thoughtworks.qdox.builder.Builder;
import com.thoughtworks.qdox.parser.*;
import com.thoughtworks.qdox.parser.expression.*;
import com.thoughtworks.qdox.parser.structs.*;
import java.io.IOException;
import java.util.LinkedList;
import java.util.List;
import java.util.Stack;
//#line 45 "Parser.java"




public class Parser
             implements CommentHandler
{

boolean yydebug;        //do I want debug output?
int yynerrs;            //number of errors so far
int yyerrflag;          //was there an error?
int yychar;             //the current working character

//########## MESSAGES ##########
//###############################################################
// method: debug
//###############################################################
void debug(String msg)
{
  if (yydebug)
    System.out.println(msg);
}

//########## STATE STACK ##########
final static int YYSTACKSIZE = 500;  //maximum stack size
int statestk[] = new int[YYSTACKSIZE]; //state stack
int stateptr;
int stateptrmax;                     //highest index of stackptr
int statemax;                        //state when highest index reached
//###############################################################
// methods: state stack push,pop,drop,peek
//###############################################################
final void state_push(int state)
{
  try {
		stateptr++;
		statestk[stateptr]=state;
	 }
	 catch (ArrayIndexOutOfBoundsException e) {
     int oldsize = statestk.length;
     int newsize = oldsize * 2;
     int[] newstack = new int[newsize];
     System.arraycopy(statestk,0,newstack,0,oldsize);
     statestk = newstack;
     statestk[stateptr]=state;
  }
}
final int state_pop()
{
  return statestk[stateptr--];
}
final void state_drop(int cnt)
{
  stateptr -= cnt; 
}
final int state_peek(int relative)
{
  return statestk[stateptr-relative];
}
//###############################################################
// method: init_stacks : allocate and prepare stacks
//###############################################################
final boolean init_stacks()
{
  stateptr = -1;
  val_init();
  return true;
}
//###############################################################
// method: dump_stacks : show n levels of the stacks
//###############################################################
void dump_stacks(int count)
{
int i;
  System.out.println("=index==state====value=     s:"+stateptr+"  v:"+valptr);
  for (i=0;i<count;i++)
    System.out.println(" "+i+"    "+statestk[i]+"      "+valstk[i]);
  System.out.println("======================");
}


//########## SEMANTIC VALUES ##########
//## **user defined:Value
String   yytext;//user variable to return contextual strings
Value yyval; //used to return semantic vals from action routines
Value yylval;//the 'lval' (result) I got from yylex()
Value valstk[] = new Value[YYSTACKSIZE];
int valptr;
//###############################################################
// methods: value stack push,pop,drop,peek.
//###############################################################
final void val_init()
{
  yyval=new Value();
  yylval=new Value();
  valptr=-1;
}
final void val_push(Value val)
{
  try {
    valptr++;
    valstk[valptr]=val;
  }
  catch (ArrayIndexOutOfBoundsException e) {
    int oldsize = valstk.length;
    int newsize = oldsize*2;
    Value[] newstack = new Value[newsize];
    System.arraycopy(valstk,0,newstack,0,oldsize);
    valstk = newstack;
    valstk[valptr]=val;
  }
}
final Value val_pop()
{
  return valstk[valptr--];
}
final void val_drop(int cnt)
{
  valptr -= cnt;
}
final Value val_peek(int relative)
{
  return valstk[valptr-relative];
}
final Value dup_yyval(Value val)
{
  return val;
}
//#### end semantic value section ####
public final static short SEMI=257;
public final static short DOT=258;
public final static short DOTDOTDOT=259;
public final static short COMMA=260;
public final static short STAR=261;
public final static short PERCENT=262;
public final static short EQUALS=263;
public final static short ANNOSTRING=264;
public final static short ANNOCHAR=265;
public final static short SLASH=266;
public final static short PLUS=267;
public final static short MINUS=268;
public final static short STAREQUALS=269;
public final static short SLASHEQUALS=270;
public final static short PERCENTEQUALS=271;
public final static short PLUSEQUALS=272;
public final static short MINUSEQUALS=273;
public final static short LESSTHAN2EQUALS=274;
public final static short GREATERTHAN2EQUALS=275;
public final static short GREATERTHAN3EQUALS=276;
public final static short AMPERSANDEQUALS=277;
public final static short CIRCUMFLEXEQUALS=278;
public final static short VERTLINEEQUALS=279;
public final static short PACKAGE=280;
public final static short IMPORT=281;
public final static short PUBLIC=282;
public final static short PROTECTED=283;
public final static short PRIVATE=284;
public final static short STATIC=285;
public final static short FINAL=286;
public final static short ABSTRACT=287;
public final static short NATIVE=288;
public final static short STRICTFP=289;
public final static short SYNCHRONIZED=290;
public final static short TRANSIENT=291;
public final static short VOLATILE=292;
public final static short CLASS=293;
public final static short INTERFACE=294;
public final static short ENUM=295;
public final static short ANNOINTERFACE=296;
public final static short THROWS=297;
public final static short EXTENDS=298;
public final static short IMPLEMENTS=299;
public final static short SUPER=300;
public final static short DEFAULT=301;
public final static short NEW=302;
public final static short BRACEOPEN=303;
public final static short BRACECLOSE=304;
public final static short SQUAREOPEN=305;
public final static short SQUARECLOSE=306;
public final static short PARENOPEN=307;
public final static short PARENCLOSE=308;
public final static short LESSTHAN=309;
public final static short GREATERTHAN=310;
public final static short LESSEQUALS=311;
public final static short GREATEREQUALS=312;
public final static short LESSTHAN2=313;
public final static short GREATERTHAN2=314;
public final static short GREATERTHAN3=315;
public final static short EXCLAMATION=316;
public final static short AMPERSAND2=317;
public final static short VERTLINE2=318;
public final static short EQUALS2=319;
public final static short NOTEQUALS=320;
public final static short TILDE=321;
public final static short AMPERSAND=322;
public final static short VERTLINE=323;
public final static short CIRCUMFLEX=324;
public final static short VOID=325;
public final static short QUERY=326;
public final static short COLON=327;
public final static short AT=328;
public final static short CODEBLOCK=329;
public final static short PARENBLOCK=330;
public final static short BYTE=331;
public final static short SHORT=332;
public final static short INT=333;
public final static short LONG=334;
public final static short CHAR=335;
public final static short FLOAT=336;
public final static short DOUBLE=337;
public final static short BOOLEAN=338;
public final static short IDENTIFIER=339;
public final static short BOOLEAN_LITERAL=340;
public final static short INTEGER_LITERAL=341;
public final static short FLOAT_LITERAL=342;
public final static short CHAR_LITERAL=343;
public final static short STRING_LITERAL=344;
public final static short PLUSPLUS=345;
public final static short MINUSMINUS=346;
public final static short YYERRCODE=256;
final static short yylhs[] = {                           -1,
    0,   43,   43,   40,   40,   45,   44,   46,   46,   46,
   46,   41,   41,   47,   48,   49,   50,   42,   52,   42,
   51,   51,   53,   53,   55,   55,   56,   56,   65,   57,
   67,   58,   69,   59,   70,   60,   62,   62,   68,   68,
   63,   63,   30,   30,   35,   35,    1,    1,    1,    1,
    1,    1,    1,    1,   36,   73,   38,   31,   31,   76,
   74,   72,   72,   39,   39,   39,   39,   75,   75,   77,
   71,   71,   78,   78,   78,   81,   79,   61,   61,   80,
   80,   84,   82,   85,   85,   83,   86,   83,   54,   54,
   87,   87,   87,   87,   87,   87,   87,   87,   87,   87,
   87,   87,   88,   88,   90,    4,   91,   91,   91,   92,
   92,   93,    5,    5,    5,   94,    6,   95,   95,   95,
   89,   89,   64,   97,   97,   98,   98,   98,   96,  101,
   96,  102,  100,   99,   99,   99,   99,   99,  104,  108,
  105,  107,  109,  107,   37,  106,  112,  110,  114,  110,
  111,  118,  116,  115,  115,  117,  119,  117,  117,  113,
  113,  120,  120,   32,   32,  121,  103,  122,  103,  123,
  123,  125,  125,  126,  127,  127,  127,   20,   20,   20,
   20,   20,   20,   20,   20,    3,    3,    3,    3,    3,
  128,   22,   22,   22,   34,   34,  130,  131,  131,  133,
  133,  124,  124,  132,  132,  134,   28,   28,   29,   29,
   21,   21,   23,   23,   23,   18,   18,   18,   18,   18,
   19,   19,   19,   19,   24,   24,   24,   17,   17,   17,
   17,   16,   16,   16,   15,   15,   15,   15,   14,   14,
   14,   14,   14,   13,   13,   13,   10,   10,   11,   11,
   12,   12,    9,    9,    8,    8,    7,    7,   27,   27,
   25,   26,   33,   33,   33,   33,   33,   33,   33,   33,
   33,   33,   33,   33,    2,  129,  129,  135,  135,   66,
  136,  136,  136,  139,  138,  137,  137,
};
final static short yylen[] = {                            2,
    3,    1,    1,    0,    2,    0,    4,    1,    1,    1,
    1,    0,    2,    3,    5,    4,    6,    0,    0,    3,
    1,    1,    2,    2,    1,    1,    1,    1,    0,    7,
    0,    5,    0,    6,    0,    4,    0,    2,    0,    2,
    0,    2,    1,    3,    2,    2,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    0,    3,    1,    3,    0,
    4,    0,    1,    2,    1,    3,    3,    1,    3,    3,
    1,    3,    0,    2,    1,    0,    4,    0,    1,    1,
    3,    0,    3,    1,    3,    0,    0,    3,    0,    2,
    1,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    0,    2,    0,    4,    0,    1,    1,    1,
    3,    3,    1,    1,    1,    0,    4,    0,    2,    2,
    0,    3,    3,    0,    1,    1,    2,    1,    0,    0,
    3,    1,    1,    1,    1,    1,    1,    1,    2,    0,
    5,    0,    0,    4,    2,    2,    0,    7,    0,    6,
    3,    0,    4,    0,    1,    1,    0,    4,    2,    0,
    2,    1,    3,    1,    1,    0,    5,    0,    6,    0,
    3,    1,    1,    3,    0,    2,    2,    1,    3,    4,
    3,    4,    1,    1,    2,    1,    1,    1,    1,    1,
    3,    3,    2,    2,    2,    4,    2,    2,    2,    1,
    3,    0,    1,    1,    2,    3,    2,    3,    0,    1,
    4,    7,    1,    2,    2,    2,    2,    2,    2,    1,
    1,    2,    2,    1,    5,    4,    5,    1,    3,    3,
    3,    1,    3,    3,    1,    3,    3,    3,    1,    3,
    3,    3,    3,    1,    3,    3,    1,    3,    1,    3,
    1,    3,    1,    3,    1,    3,    1,    5,    1,    1,
    3,    1,    1,    1,    1,    1,    1,    1,    1,    1,
    1,    1,    1,    1,    1,    0,    1,    1,    2,    4,
    0,    2,    2,    0,    5,    0,    2,
};
final static short yydefred[] = {                         4,
    0,    0,    6,    0,    3,    0,    5,    2,    0,   43,
    0,    0,    0,   13,    8,    9,   10,   11,    0,    0,
    0,    0,    0,    0,    7,   44,    0,  106,    0,   14,
    0,   22,   20,   21,    0,    0,    0,    0,    0,    0,
    0,   47,   48,   50,   51,   49,   52,   53,   54,    0,
  190,  186,  187,  188,  189,    0,    0,    0,  178,  114,
  109,  115,  113,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  228,  220,  213,  184,    0,  224,    0,
    0,    0,  110,    0,   16,    0,    0,   92,   93,   94,
   95,   96,   97,   98,  102,   99,  101,  100,    0,    0,
    0,    0,   91,   23,   24,   25,   26,   27,   28,   90,
    0,  218,  219,    0,    0,  185,    0,    0,    0,    0,
  259,  260,    0,  275,    0,  223,  222,    0,    0,  216,
  217,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  214,  215,    0,    0,  122,    0,
  118,    0,   15,    0,    0,    0,   35,    0,   56,   71,
    0,    0,    0,   75,  195,    0,    0,    0,    0,    0,
  193,  194,    0,  204,    0,    0,  179,  263,  266,  267,
  271,  264,  265,  272,  273,  274,  268,  270,  269,    0,
    0,    0,  112,  200,    0,    0,    0,  207,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  229,  231,  230,
  181,   76,    0,   79,    0,    0,  111,    0,   17,    0,
    0,    0,   31,    0,    0,    0,    0,   70,   74,    0,
    0,    0,  278,    0,    0,  175,  198,  129,  125,  197,
  199,  205,  192,    0,  261,  226,    0,  211,    0,  208,
  180,    0,    0,    0,  182,  120,  117,  119,    0,    0,
    0,   33,    0,    0,   36,   60,   57,   63,   59,   72,
    0,    0,   68,    0,  196,  206,  191,  279,    0,    0,
  225,  227,  201,  258,   82,    0,   80,    0,   38,   29,
    0,    0,  281,   32,    0,    0,   64,    0,   61,  177,
  174,  173,  176,  172,  123,    0,    0,    0,   77,    0,
    0,   34,    0,    0,   66,    0,   67,   69,  126,    0,
  131,  128,  133,   87,   83,   81,  212,   30,  129,  282,
    0,    0,  283,   45,   46,  139,    0,    0,  137,  138,
    0,  127,  136,  132,  134,  135,    0,    0,    0,  284,
  104,  280,    0,    0,  140,    0,    0,  165,  164,  146,
   84,    0,    0,    0,    0,  145,    0,  142,    0,  147,
    0,    0,    0,    0,    0,  155,    0,    0,    0,    0,
    0,    0,   85,    0,  285,  152,  151,    0,    0,  167,
    0,  141,  143,    0,    0,  171,    0,    0,  150,    0,
  169,    0,    0,    0,    0,  153,    0,  144,  148,  159,
    0,   89,  158,
};
final static short yydgoto[] = {                          1,
   58,  204,   59,   60,   61,   62,  121,   64,   65,   66,
   67,   68,   69,   70,   71,   72,   73,   74,   75,   76,
   77,  116,   78,   79,  122,  123,  124,  133,  386,   80,
  169,  380,  200,  117,  335,  336,  375,  171,  293,    2,
    6,   13,    7,    8,    9,   14,   15,   16,   17,   18,
   33,   24,   34,  394,  104,  105,  106,  107,  108,  109,
  233,  280,  243,  259,  331,  314,  284,  282,  312,  244,
  172,  287,  245,  174,  294,  250,  118,  175,  234,  306,
  273,  307,  345,  327,  382,  368,  110,  351,   28,   21,
   81,   82,   83,   84,  238,  300,  260,  341,  362,  342,
  326,  363,  364,  343,  365,  366,  400,  388,  420,  367,
  385,  402,  398,  387,  395,  396,  426,  417,  431,  409,
  373,  389,  393,  206,  323,  257,  299,  180,  254,  181,
  182,  183,  207,  184,  255,  333,  352,  353,  383,
};
final static short yysindex[] = {                         0,
    0, -121,    0, -314,    0, -251,    0,    0, -314,    0,
 -219, -263,    0,    0,    0,    0,    0,    0,   80, -281,
 -187, -314,   82, -174,    0,    0, 2766,    0,   87,    0,
 -220,    0,    0,    0,  371, 2901, 2901, -288, 2901, 2901,
 2901,    0,    0,    0,    0,    0,    0,    0,    0,  -40,
    0,    0,    0,    0,    0, 2901, 2901, -171,    0,    0,
    0,    0,    0,  -68, -159, -158, -143, -101,   27,  -11,
   -5,   81,   23,    0,    0,    0,    0,    5,    0, -102,
 -118,    6,    0,  -49,    0, -216,  -10,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  -79,  -60,
  -45,  -43,    0,    0,    0,    0,    0,    0,    0,    0,
  -19,    0,    0, -314,  -37,    0,  -70,  -26, -171,   -2,
    0,    0,  307,    0, -123,    0,    0, 2811, 2901,    0,
    0,   36,   53,  102, 2901, 2901, 2901, 2901, 2901, 2901,
 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901, 2901,
 2901, 2901, 2901, 2901,    0,    0,  -48,  -94,    0,   26,
    0,  109,    0,   58,   58,   69,    0, -219,    0,    0,
  111, -231,   60,    0,    0,   32, 2856, 2901,  -72,   71,
    0,    0,   67,    0, -243, -107,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, 2901,
 3038, -119,    0,    0, -102,   70,  115,    0,   73,   84,
 -159,   54, -158, -143, -101,   27,  -11,  -11,   -5,   -5,
   -5,   -5,   81,   81,   81,   23,   23,    0,    0,    0,
    0,    0,   41,    0,   89,  122,    0, 2404,    0,   88,
   91, -314,    0,   71,   83,   52, -314,    0,    0, -273,
  -37,  107,    0,   86, 2901,    0,    0,    0,    0,    0,
    0,    0,    0, 2901,    0,    0, 3038,    0, 2901,    0,
    0, 2901,   76,  110,    0,    0,    0,    0, -314,   69,
 -314,    0,  156,  118,    0,    0,    0,    0,    0,    0,
   35, -171,    0, -100,    0,    0,    0,    0, 2449,  123,
    0,    0,    0,    0,    0,  -98,    0, 2901,    0,    0,
  156,   71,    0,    0,  -12,  -12,    0, -273,    0,    0,
    0,    0,    0,    0,    0,  165,  128,   76,    0,  120,
   71,    0,  -58, -171,    0, -171,    0,    0,    0, 2966,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -271,  125,    0,    0,    0,    0,    0,   92,    0,    0,
  144,    0,    0,    0,    0,    0, -217, -314,    0,    0,
    0,    0,  126, -171,    0,    0,   95,    0,    0,    0,
    0,  108,  129,    0,  138,    0,  126,    0,  126,    0,
 -314, 2901,   71, 2551,  130,    0, -314, -217, -171,   45,
  138,  126,    0,  131,    0,    0,    0,  111,  180,    0,
  138,    0,    0,  112, -171,    0, -228, -314,    0,  103,
    0,  138,  103, -171,    0,    0,  111,    0,    0,    0,
  183,    0,    0,
};
final static short yyrindex[] = {                         0,
    0,  334,    0,    0,    0,  271,    0,    0,    0,    0,
  116,    0,  318,    0,    0,    0,    0,    0,    0,    0,
  206,    0,    0,  464,    0,    0,  -35,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0, -224,
    0,    0,    0,    0,    0,    0,    0,  188,    0,    0,
    0,    0,    0, 2359, 2269, 2179, 2089, 1999, 1909, 1774,
 1339, 1117,  898,    0,    0,    0,    0, 2602,    0,  637,
    0,  157,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  463,    0,    0,    0,  -63,    0,    0,    0,  -92,    0,
    0,    0,    0,    0, 2535,    0,    0,  161,  159,    0,
    0,    0,  374,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,   -6,  -22,  166,    0, -142,    0,    0,
  -90,    0, -272,    0,    0,    0,    0,  160,    0,  811,
    0,    0,  724,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  550,    0,  162,    0,    0,    0,
 2314,    0, 2224, 2134, 2044, 1954, 1819, 1864, 1426, 1513,
 1600, 1687, 1162, 1207, 1252,  985, 1072,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  161,    0,  -13,
  169,    0,    0,    0, -105,    0,    0,    0,    0,    0,
  -63,    0,    0,    0,  163,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  166,
    0,    0,  181,    0,    0,    0,    0,    0,    0,    0,
  -88,  -84,    0,    0,    0,    0,    0,    0,    0, 2728,
    0,    0,    0,    0,    0,    0,    0,  159,    0,    0,
  182,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0, 2997,  -82,    0,    0,    0,
    0,    0, -278, -232,    0, -232,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0, -235,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0, 2670,    0,
    0,    0,    0, -115,    0, -234,    0,    0,    0,    0,
    0,  -81, -120, 3029, -198,    0,    0,    0,    0,    0,
    0,  159, -195,    0,    0,    0,    0,    0, -237,    0,
  174,    0,    0,    0,    0,    0,    0, -205, -188,    0,
 -198,    0,    0,    0, -237,    0,    0,    0,    0,    0,
    0, -198,    0, -211,  -67,    0, -180,    0,    0,    0,
    0,    0,    0,
};
final static short yygindex[] = {                         0,
  -33,  -30,    0,    1, -124,    0,  -20,    0,  369,  368,
  373,  367,  372,  212,  186,  168,  205,  -24, -154,    0,
    0,    0,    0,    0,    0,    0,  313,  -69,  -56,   -4,
    0,  119,    0,  389, -190, -104, -161, -170,  200,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  -23,  176,  179,    0,    0,    0,    0,
  198,    0,  240, -230,    0,    0,    0,    0,    0,    0,
  -51,    0,    0,  276,    0,    0,    0,  272,  184,    0,
    0,  197,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  366,    0,    0,  187,  136,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
 -132,    0, -148,    0,    0,   98,    0,    0,    0,    0,
    0,    0,    0, -289,    0,  232,    0,    0,    0,  347,
    0,    0,    0,  350,    0,    0,    0,    0,    0,
};
final static int YYTABLESIZE=3382;
static short yytable[];
static { yytable();}
static void yytable(){
yytable = new short[]{                         11,
   35,  134,    5,  203,   19,  119,   63,   23,  120,  170,
  158,  112,  113,  285,  176,  126,  127,   29,  330,  209,
  114,   22,   43,   43,   10,  286,  209,  209,  247,   12,
  423,  130,  131,   43,  125,  103,   43,   43,   20,  378,
   87,   43,   43,   43,  162,  209,  266,  179,  209,  103,
  115,  162,  291,   60,  162,  202,    4,   26,  160,  209,
  103,  124,  186,  178,  124,   10,   60,  370,  161,   43,
   43,  166,  168,   43,   43,   10,  163,  209,  248,  163,
   43,  332,   32,   43,   43,   43,   43,   43,   43,   43,
   43,  209,   43,   43,   43,   43,  209,   43,   43,   43,
  348,   43,  404,   43,   43,  212,  209,   63,  124,  168,
  424,  379,  302,  278,   58,  105,   58,   58,   26,   27,
   43,   43,   26,  162,  205,  337,  261,  228,  229,  230,
  160,  205,  124,  132,  157,  158,  170,  170,  235,  170,
  161,  209,  290,  124,  209,  292,  252,  253,  163,  358,
  210,   62,   62,   62,   62,  157,   58,  137,    3,  318,
   58,  328,   58,  235,  138,  209,   58,   58,   55,   55,
  377,   65,  205,  205,  309,  209,  170,   86,   88,   58,
  139,  132,  170,  170,  201,  209,   58,  176,  267,  159,
  283,  149,  157,   62,   73,  205,   58,   62,  349,   62,
  264,  350,  132,  406,   62,  121,    4,  170,   55,  319,
  209,  329,   55,  292,   55,  209,   62,   63,  170,   55,
  140,   65,  128,   62,  298,  209,  408,   86,   88,  311,
  256,   55,  209,   62,  177,  317,  178,  168,  303,  301,
  156,   73,  168,   73,  231,  168,  163,  427,   55,  135,
  205,  304,  414,  161,  399,  425,  401,  136,  428,  164,
  232,  430,  419,  381,  205,  160,  129,  116,  322,  415,
   18,  173,  107,  429,  168,   78,  168,  354,  165,  355,
   78,  334,  334,  152,  153,   37,  403,  129,  154,   37,
   26,   78,   78,  166,  205,  167,   78,  143,  144,  145,
  146,  412,  340,  205,  413,  187,  334,  147,  148,  149,
  168,  168,  115,  168,  223,  224,  225,    1,   42,   43,
   44,   45,   46,   47,   48,   49,   10,  334,  219,  220,
  221,  222,  315,   12,  316,  168,   25,   20,   30,   31,
  103,  208,  411,   85,   86,  141,  142,  150,  151,  155,
  156,  371,  217,  218,  226,  227,  168,  209,  422,  210,
  334,  240,  241,  168,  236,  239,  232,  242,  246,  249,
  251,  177,  105,  258,  269,  105,  271,  268,  270,  274,
  272,  275,  105,  105,  128,  279,  168,  205,  281,  168,
  289,  286,  168,  297,  103,  105,  105,  105,  105,  105,
  105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
  105,  105,  296,  168,  305,  247,  308,  105,  105,  105,
  313,  339,  105,  105,  105,  344,  325,  347,  372,  391,
  374,  105,  384,  390,  397,  392,  105,  407,  416,  418,
  421,  424,  432,  105,  105,  209,  105,  105,  105,  105,
  105,  105,  105,  105,  105,  105,  105,  105,  105,  105,
  105,  105,  121,  116,  108,  121,  202,  276,   41,  203,
  277,   39,  121,  121,   42,   43,   44,   45,   46,   47,
   48,   49,  376,   42,   40,  121,  121,  121,  121,  121,
  121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
  121,  121,  160,  211,  213,  215,  185,  121,  121,  121,
  214,  216,  265,  121,  121,  359,  410,  338,  360,  310,
  288,  121,  295,  361,  346,  237,  121,   18,  405,  433,
  324,  263,  262,  121,  121,  369,  121,  121,  121,  121,
  121,  121,  121,  121,  121,  121,  121,  121,  121,  121,
  121,  121,   18,   18,   18,   18,   18,   18,   18,   18,
   18,   18,   18,   18,   18,   18,   18,    0,    0,  188,
    0,    0,    0,    0,   19,  189,  190,  191,  192,  193,
  194,  195,  196,  197,  198,  199,    0,    0,    0,    0,
   12,    0,    0,    0,    0,    0,    0,    0,   18,   19,
   19,   19,   19,   19,   19,   19,   19,   19,   19,   19,
   19,   19,   19,   19,   12,   12,   12,   12,   12,   12,
   12,   12,   12,   12,   12,   12,   12,   12,   12,   12,
  210,  210,  210,  210,  210,  210,    0,    0,    0,  210,
  210,  210,    0,    0,    0,   19,    0,    0,    0,    0,
    0,    0,   88,   89,   90,   91,   92,   93,   94,   95,
   96,   97,   98,   99,  100,  101,  102,    0,    0,    0,
  210,    0,    0,    0,    0,  210,  210,  210,    0,  210,
  210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
  210,  210,  210,  210,  210,  210,  210,  210,    4,  210,
  210,  210,  210,    0,  210,  210,  210,  210,  210,  210,
  210,  210,  210,  210,  210,  210,  210,  210,  210,  210,
   43,    0,   43,   43,   43,   43,    0,    0,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,    0,    0,    0,   89,   89,   89,   89,   89,
   89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
    0,    0,    0,    0,   43,   43,   43,   43,   43,    0,
   43,   43,   43,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,    0,   43,   43,
   43,   89,    0,   43,   43,   43,   43,   43,   43,   43,
   43,   43,   43,   43,   43,   43,   43,   43,   43,  183,
  183,  183,  262,    0,    0,  183,  183,  183,  262,  262,
  262,  262,  262,  262,  262,  262,  262,  262,  262,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  183,  183,  183,    0,  183,  183,  183,  183,  183,
  183,  183,  183,  183,  183,  183,  183,  183,  183,  183,
  183,  183,  183,  183,    0,  183,  183,    0,    0,    0,
  183,  183,  183,  183,  183,  183,  183,  183,  183,  183,
  183,  183,  183,  183,  183,  183,  183,  183,  183,    0,
    0,    0,  183,  183,  183,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  183,  183,
  183,    0,  183,  183,  183,  183,  183,  183,  183,  183,
  183,  183,  183,  183,  183,  183,  183,  183,  183,  183,
  183,    0,  183,  183,  183,    0,    0,  183,  183,  183,
  183,  183,  183,  183,  183,  183,  183,  183,  183,  183,
  183,  183,  183,  209,  209,  209,    0,    0,    0,  209,
  209,  209,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  209,  209,  209,    0,  209,
  209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
  209,  209,  209,  209,  209,  209,  209,  209,    0,  209,
  209,  209,    0,    0,  209,  209,  209,  209,  209,  209,
  209,  209,  209,  209,  209,  209,  209,  209,  209,  209,
  124,  124,  124,    0,    0,    0,  124,  124,  124,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,  124,    0,  124,    0,  124,  124,  124,  124,
  124,  124,  124,  124,  124,  124,  124,  124,  124,  124,
  124,  124,  124,  124,  124,    0,  124,  124,  124,    0,
    0,  124,  124,  124,  124,  124,  124,  124,  124,  124,
  124,  124,  124,  124,  124,  124,  124,  232,    0,    0,
    0,    0,    0,    0,  232,  232,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,  232,
  232,  232,    0,  232,  232,  232,  232,  232,  232,  232,
  232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
  232,  232,    0,  232,  232,  232,    0,    0,  232,  232,
  232,  232,  232,  232,  232,  232,  232,  232,  232,  232,
  232,  232,  232,  232,  233,    0,    0,    0,    0,    0,
    0,  233,  233,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,  233,  233,  233,    0,
  233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
  233,  233,  233,  233,  233,  233,  233,  233,  233,    0,
  233,  233,  233,    0,    0,  233,  233,  233,  233,  233,
  233,  233,  233,  233,  233,  233,  233,  233,  233,  233,
  233,  234,    0,    0,    0,    0,    0,    0,  234,  234,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  234,  234,  234,  235,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,    0,  234,  234,  234,
    0,    0,  234,  234,  234,  234,  234,  234,  234,  234,
  234,  234,  234,  234,  234,  234,  234,  234,  235,  235,
  235,  236,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,    0,  235,  235,  235,    0,    0,  235,  235,  235,
  235,  235,  235,  235,  235,  235,  235,  235,  235,  235,
  235,  235,  235,  236,  236,  236,  238,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,    0,  236,  236,  236,
    0,    0,  236,  236,  236,  236,  236,  236,  236,  236,
  236,  236,  236,  236,  236,  236,  236,  236,  238,  238,
  238,  237,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,    0,  238,  238,  238,    0,    0,  238,  238,  238,
  238,  238,  238,  238,  238,  238,  238,  238,  238,  238,
  238,  238,  238,  237,  237,  237,    0,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,    0,  237,  237,  237,
    0,    0,  237,  237,  237,  237,  237,  237,  237,  237,
  237,  237,  237,  237,  237,  237,  237,  237,  239,    0,
    0,    0,    0,    0,    0,  239,  239,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
  239,  239,  239,    0,  239,  239,  239,  239,  239,  239,
  239,    0,    0,    0,  239,  239,  239,  239,  239,  239,
  239,  239,  239,    0,  239,  239,  239,    0,    0,  239,
  239,  239,  239,  239,  239,  239,  239,  239,  239,  239,
  239,  239,  239,  239,  239,  242,    0,    0,    0,    0,
    0,    0,  242,  242,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  242,  242,  242,
    0,  242,  242,  242,  242,  242,  242,  242,    0,    0,
    0,  242,  242,  242,  242,  242,  242,  242,  242,  242,
    0,  242,  242,  242,    0,    0,  242,  242,  242,  242,
  242,  242,  242,  242,  242,  242,  242,  242,  242,  242,
  242,  242,  243,    0,    0,    0,    0,    0,    0,  243,
  243,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  243,  243,  243,    0,  243,  243,
  243,  243,  243,  243,  243,    0,    0,    0,  243,  243,
  243,  243,  243,  243,  243,  243,  243,    0,  243,  243,
  243,    0,    0,  243,  243,  243,  243,  243,  243,  243,
  243,  243,  243,  243,  243,  243,  243,  243,  243,  240,
    0,    0,    0,    0,    0,    0,  240,  240,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,  240,  240,  240,    0,  240,  240,  240,  240,  240,
  240,  240,    0,    0,    0,  240,  240,  240,  240,  240,
  240,  240,  240,  240,    0,  240,  240,  240,    0,    0,
  240,  240,  240,  240,  240,  240,  240,  240,  240,  240,
  240,  240,  240,  240,  240,  240,  241,    0,    0,    0,
    0,    0,    0,  241,  241,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,  241,  241,
  241,    0,  241,  241,  241,  241,  241,  241,  241,    0,
    0,    0,  241,  241,  241,  241,  241,  241,  241,  241,
  241,    0,  241,  241,  241,    0,    0,  241,  241,  241,
  241,  241,  241,  241,  241,  241,  241,  241,  241,  241,
  241,  241,  241,  244,    0,    0,    0,    0,    0,    0,
  244,  244,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  244,  244,  244,  245,  244,
  244,  244,    0,    0,    0,  245,  245,    0,    0,  244,
  244,  244,  244,  244,  244,  244,  244,  244,    0,  244,
  244,  244,    0,    0,  244,  244,  244,  244,  244,  244,
  244,  244,  244,  244,  244,  244,  244,  244,  244,  244,
  245,  245,  245,  246,  245,  245,  245,    0,    0,    0,
  246,  246,    0,    0,  245,  245,  245,  245,  245,  245,
  245,  245,  245,    0,  245,  245,  245,    0,    0,  245,
  245,  245,  245,  245,  245,  245,  245,  245,  245,  245,
  245,  245,  245,  245,  245,  246,  246,  246,  251,  246,
  246,  246,    0,    0,    0,  251,  251,    0,    0,  246,
  246,  246,  246,  246,  246,  246,  246,  246,    0,  246,
  246,  246,    0,    0,  246,  246,  246,  246,  246,  246,
  246,  246,  246,  246,  246,  246,  246,  246,  246,  246,
  251,  251,  251,  252,  251,  251,  251,    0,    0,    0,
  252,  252,    0,    0,  251,  251,  251,    0,    0,  251,
  251,  251,  251,    0,  251,  251,  251,    0,    0,  251,
  251,  251,  251,  251,  251,  251,  251,  251,  251,  251,
  251,  251,  251,  251,  251,  252,  252,  252,  249,  252,
  252,  252,    0,    0,    0,  249,  249,    0,    0,  252,
  252,  252,    0,    0,  252,  252,  252,  252,    0,  252,
  252,  252,    0,    0,  252,  252,  252,  252,  252,  252,
  252,  252,  252,  252,  252,  252,  252,  252,  252,  252,
  249,  249,  249,  250,  249,  249,  249,    0,    0,    0,
  250,  250,    0,    0,  249,  249,  249,    0,    0,  249,
    0,  249,  249,    0,  249,  249,  249,    0,    0,  249,
  249,  249,  249,  249,  249,  249,  249,  249,  249,  249,
  249,  249,  249,  249,  249,  250,  250,  250,  247,  250,
  250,  250,    0,    0,    0,  247,  247,    0,    0,  250,
  250,  250,    0,    0,  250,    0,  250,  250,    0,  250,
  250,  250,    0,    0,  250,  250,  250,  250,  250,  250,
  250,  250,  250,  250,  250,  250,  250,  250,  250,  250,
  247,  247,  247,  248,  247,  247,  247,    0,    0,    0,
  248,  248,    0,    0,  247,  247,  247,    0,    0,  247,
    0,  247,    0,    0,  247,  247,  247,    0,    0,  247,
  247,  247,  247,  247,  247,  247,  247,  247,  247,  247,
  247,  247,  247,  247,  247,  248,  248,  248,  253,  248,
  248,  248,    0,    0,    0,  253,  253,    0,    0,  248,
  248,  248,    0,    0,  248,    0,  248,    0,    0,  248,
  248,  248,    0,    0,  248,  248,  248,  248,  248,  248,
  248,  248,  248,  248,  248,  248,  248,  248,  248,  248,
  253,  253,  253,  254,  253,  253,  253,    0,    0,    0,
  254,  254,    0,    0,  253,  253,  253,    0,    0,  253,
    0,    0,    0,    0,  253,  253,  253,    0,    0,  253,
  253,  253,  253,  253,  253,  253,  253,  253,  253,  253,
  253,  253,  253,  253,  253,  254,  254,  254,  255,  254,
  254,  254,    0,    0,    0,  255,  255,    0,    0,  254,
  254,  254,    0,    0,  254,    0,    0,    0,    0,  254,
  254,  254,    0,    0,  254,  254,  254,  254,  254,  254,
  254,  254,  254,  254,  254,  254,  254,  254,  254,  254,
  255,  255,  255,  256,  255,  255,  255,    0,    0,    0,
  256,  256,    0,    0,  255,    0,  255,    0,    0,  255,
    0,    0,    0,    0,  255,  255,  255,    0,    0,  255,
  255,  255,  255,  255,  255,  255,  255,  255,  255,  255,
  255,  255,  255,  255,  255,  256,  256,  256,  257,  256,
  256,  256,    0,    0,    0,  257,  257,    0,    0,  256,
    0,  256,    0,    0,  256,    0,    0,    0,    0,  256,
  256,  256,    0,    0,  256,  256,  256,  256,  256,  256,
  256,  256,  256,  256,  256,  256,  256,  256,  256,  256,
  257,  257,  257,  276,  257,  257,  257,    0,    0,    0,
   36,   37,    0,    0,  257,    0,    0,    0,    0,  257,
    0,    0,    0,    0,    0,  257,  257,    0,    0,  257,
  257,  257,  257,  257,  257,  257,  257,  257,  257,  257,
  257,  257,  257,  257,  257,   38,    0,  277,  320,    0,
   39,    0,    0,    0,    0,   36,   37,    0,    0,   40,
    0,    0,    0,    0,   41,    0,    0,    0,    0,    0,
    0,    4,    0,    0,   42,   43,   44,   45,   46,   47,
   48,   49,  111,   51,   52,   53,   54,   55,   56,   57,
   38,  256,  321,    0,    0,   39,    0,    0,    0,    0,
    0,    0,    0,    0,   40,    0,    0,    0,    0,   41,
    0,    0,    0,    0,    0,    0,    0,    0,    0,   42,
   43,   44,   45,   46,   47,   48,   49,  111,   51,   52,
   53,   54,   55,   56,   57,  183,  183,  262,    0,    0,
  183,  183,  183,  262,  262,  262,  262,  262,  262,  262,
  262,  262,  262,  262,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,   88,   89,   90,   91,   92,   93,   94,   95,
   96,   97,   98,  183,  183,  183,  183,  183,  183,  183,
    0,  183,  183,  183,  183,    0,  183,  183,  183,    0,
  183,  221,  221,  221,    0,    0,    0,  221,  221,  221,
    0,    0,    0,    0,    0,    0,    0,    0,    4,  183,
  183,   42,   43,   44,   45,   46,   47,   48,   49,   10,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,  221,  221,  221,    0,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,  130,  221,  221,  221,
    0,    0,  221,  221,  221,  221,  221,  221,  221,  221,
  221,  221,  221,  221,  221,  221,    0,    0,    0,    0,
    0,  130,  130,  130,  130,  130,  130,  130,  130,  130,
  130,  130,  130,  130,  130,  130,    0,    0,    0,    0,
    0,    0,    0,  287,    0,    0,    0,    0,  130,    0,
    0,    0,    0,    0,  130,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,  130,  130,    0,
  130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
  130,  130,  130,  130,  130,  130,  130,  130,  130,  130,
  130,  130,  130,  130,    0,    0,    0,    0,    0,    0,
    0,    0,   36,   37,    0,    0,  130,    0,    0,    0,
    0,    0,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,    0,  130,  130,    0,  130,  130,
  130,  130,  130,  130,  130,  130,  130,   38,    0,    0,
    0,    0,   39,    0,    0,    0,    0,   36,   37,    0,
    0,   40,    0,    0,    0,    0,   41,    0,    0,    0,
    0,    0,    0,    4,    0,    0,   42,   43,   44,   45,
   46,   47,   48,   49,   50,   51,   52,   53,   54,   55,
   56,   57,   38,    0,    0,    0,    0,   39,    0,    0,
    0,    0,   36,   37,    0,    0,   40,    0,    0,    0,
    0,   41,    0,    0,    0,    0,    0,    0,    4,    0,
    0,   42,   43,   44,   45,   46,   47,   48,   49,  111,
   51,   52,   53,   54,   55,   56,   57,   38,    0,    0,
    0,  208,   39,    0,    0,    0,    0,   36,   37,    0,
    0,   40,    0,    0,    0,    0,   41,    0,    0,    0,
    0,    0,    0,    0,    0,    0,   42,   43,   44,   45,
   46,   47,   48,   49,  111,   51,   52,   53,   54,   55,
   56,   57,   38,    0,    0,    0,    0,   39,    0,    0,
    0,    0,    0,    0,    0,    0,   40,    0,    0,    0,
    0,   41,    0,    0,    0,    0,    0,    0,    0,    0,
    0,   42,   43,   44,   45,   46,   47,   48,   49,  111,
   51,   52,   53,   54,   55,   56,   57,   88,   89,   90,
   91,   92,   93,   94,   95,   96,   97,   98,   99,  100,
  101,  102,    0,    0,    0,    0,    0,    0,    0,    0,
    0,    0,    0,    0,  232,    0,    0,    0,   89,   89,
   89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
   89,   89,   89,    4,  356,    0,   42,   43,   44,   45,
   46,   47,   48,   49,  357,   89,    0,    0,    0,    0,
   89,   89,   89,   89,   89,   89,   89,   89,   89,   89,
   89,    0,    0,    0,   89,   89,    0,   89,   89,   89,
   89,   89,   89,   89,   89,   89,  154,    0,    0,   38,
    0,    0,    0,    0,   39,    0,    0,    0,    0,    0,
    0,    0,    0,   40,    0,    0,   89,    0,   41,   89,
   89,   89,   89,   89,   89,   89,   89,   89,   42,   43,
   44,   45,   46,   47,   48,   49,  111,   51,   52,   53,
   54,   55,
};
}
static short yycheck[];
static { yycheck(); }
static void yycheck() {
yycheck = new short[] {                          4,
   24,   58,    2,  128,    9,   39,   27,   12,   39,  114,
   80,   36,   37,  244,  258,   40,   41,   22,  308,  257,
  309,  285,  258,  258,  339,  304,  259,  260,  260,  281,
  259,   56,   57,  258,   39,   35,  261,  262,  258,  257,
  261,  266,  267,  268,  261,  257,  201,  117,  260,  328,
  339,  257,  326,  326,  260,  125,  328,  339,  257,  297,
  339,  257,  119,  307,  260,  339,  339,  339,  257,  305,
  305,  307,  307,  309,  309,  339,  257,  310,  310,  260,
  305,  312,  257,  308,  309,  310,  311,  312,  313,  314,
  315,  329,  317,  318,  319,  320,  308,  322,  323,  324,
  331,  326,  392,  339,  339,  136,  339,  128,  304,  114,
  339,  329,  267,  238,  257,    0,  259,  260,  339,  307,
  345,  346,  339,  329,  129,  316,  183,  152,  153,  154,
  329,  136,  328,  305,  258,  205,  257,  242,  258,  260,
  329,  257,  247,  339,  260,  250,  177,  178,  329,  340,
  258,  257,  258,  259,  260,  258,  299,  317,  280,  260,
  303,  260,  305,  258,  323,  258,  309,  310,  259,  260,
  361,  260,  177,  178,  279,  260,  281,  260,  260,  322,
  324,  305,  303,  304,  308,  305,  329,  258,  308,  308,
  242,  307,  260,  299,  258,  200,  339,  303,  257,  305,
  308,  260,  305,  394,  310,    0,  328,  328,  299,  310,
  305,  310,  303,  318,  305,  308,  322,  238,  339,  310,
  322,  310,  263,  329,  255,  310,  397,  310,  310,  281,
  303,  322,  305,  339,  305,  292,  307,  242,  269,  264,
  308,  305,  247,  307,  293,  250,  257,  418,  339,  318,
  255,  272,  401,  303,  387,  417,  389,  326,  420,  339,
  309,  423,  411,  368,  269,  260,  307,  303,  299,  402,
    0,  309,  308,  422,  279,  298,  281,  334,  339,  336,
  303,  315,  316,  261,  262,  299,  391,  307,  266,  303,
  339,  298,  299,  339,  299,  339,  303,  309,  310,  311,
  312,  257,  326,  308,  260,  308,  340,  313,  314,  315,
  315,  316,  339,  318,  147,  148,  149,    0,  331,  332,
  333,  334,  335,  336,  337,  338,  339,  361,  143,  144,
  145,  146,  298,    0,  300,  340,  257,  258,  257,  258,
  340,  306,  399,  257,  258,  319,  320,  267,  268,  345,
  346,  351,  141,  142,  150,  151,  361,  305,  415,  258,
  394,  164,  165,  368,  339,  257,  309,  299,  258,  310,
  339,  305,  257,  303,  260,  260,  293,  308,  306,  339,
  327,  293,  267,  268,  263,  298,  391,  392,  298,  394,
  339,  309,  397,  308,  394,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  306,  418,  339,  260,  307,  302,  303,  304,
  303,  257,  307,  308,  309,  298,  304,  308,  304,  322,
  339,  316,  307,  339,  297,  307,  321,  308,  308,  260,
  329,  339,  260,  328,  329,  258,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  257,  303,  308,  260,  308,  308,  303,  308,
  308,  303,  267,  268,  331,  332,  333,  334,  335,  336,
  337,  338,  339,  303,  303,  280,  281,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,  329,  135,  137,  139,  118,  302,  303,  304,
  138,  140,  200,  308,  309,  340,  398,  318,  340,  280,
  245,  316,  251,  340,  328,  160,  321,  257,  393,  432,
  299,  185,  183,  328,  329,  349,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,   -1,   -1,  263,
   -1,   -1,   -1,   -1,  257,  269,  270,  271,  272,  273,
  274,  275,  276,  277,  278,  279,   -1,   -1,   -1,   -1,
  257,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  328,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,  281,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
  257,  258,  259,  260,  261,  262,   -1,   -1,   -1,  266,
  267,  268,   -1,   -1,   -1,  328,   -1,   -1,   -1,   -1,
   -1,   -1,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  293,  294,  295,  296,   -1,   -1,   -1,
  297,   -1,   -1,   -1,   -1,  302,  303,  304,   -1,  306,
  307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,  328,  326,
  327,  328,  329,   -1,  331,  332,  333,  334,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  258,   -1,  260,  261,  262,  263,   -1,   -1,  266,  267,
  268,  269,  270,  271,  272,  273,  274,  275,  276,  277,
  278,  279,   -1,   -1,   -1,  282,  283,  284,  285,  286,
  287,  288,  289,  290,  291,  292,  293,  294,  295,  296,
   -1,   -1,   -1,   -1,  302,  303,  304,  305,  306,   -1,
  308,  309,  310,  311,  312,  313,  314,  315,  316,  317,
  318,  319,  320,  321,  322,  323,  324,   -1,  326,  327,
  328,  328,   -1,  331,  332,  333,  334,  335,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  260,
  261,  262,  263,   -1,   -1,  266,  267,  268,  269,  270,
  271,  272,  273,  274,  275,  276,  277,  278,  279,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  302,  303,  304,   -1,  306,  307,  308,  309,  310,
  311,  312,  313,  314,  315,  316,  317,  318,  319,  320,
  321,  322,  323,  324,   -1,  326,  327,   -1,   -1,   -1,
  331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  260,  261,  262,   -1,
   -1,   -1,  266,  267,  268,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  302,  303,
  304,   -1,  306,  307,  308,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
  324,   -1,  326,  327,  328,   -1,   -1,  331,  332,  333,
  334,  335,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  260,  261,  262,   -1,   -1,   -1,  266,
  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  302,  303,  304,   -1,  306,
  307,  308,  309,  310,  311,  312,  313,  314,  315,  316,
  317,  318,  319,  320,  321,  322,  323,  324,   -1,  326,
  327,  328,   -1,   -1,  331,  332,  333,  334,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  260,  261,  262,   -1,   -1,   -1,  266,  267,  268,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  302,   -1,  304,   -1,  306,  307,  308,  309,
  310,  311,  312,  313,  314,  315,  316,  317,  318,  319,
  320,  321,  322,  323,  324,   -1,  326,  327,  328,   -1,
   -1,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  260,   -1,   -1,
   -1,   -1,   -1,   -1,  267,  268,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  302,
  303,  304,   -1,  306,  307,  308,  309,  310,  311,  312,
  313,  314,  315,  316,  317,  318,  319,  320,  321,  322,
  323,  324,   -1,  326,  327,  328,   -1,   -1,  331,  332,
  333,  334,  335,  336,  337,  338,  339,  340,  341,  342,
  343,  344,  345,  346,  260,   -1,   -1,   -1,   -1,   -1,
   -1,  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  302,  303,  304,   -1,
  306,  307,  308,  309,  310,  311,  312,  313,  314,  315,
  316,  317,  318,  319,  320,  321,  322,  323,  324,   -1,
  326,  327,  328,   -1,   -1,  331,  332,  333,  334,  335,
  336,  337,  338,  339,  340,  341,  342,  343,  344,  345,
  346,  260,   -1,   -1,   -1,   -1,   -1,   -1,  267,  268,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  302,  303,  304,  260,  306,  307,  308,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
  319,  320,  321,  322,  323,  324,   -1,  326,  327,  328,
   -1,   -1,  331,  332,  333,  334,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  302,  303,
  304,  260,  306,  307,  308,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
  324,   -1,  326,  327,  328,   -1,   -1,  331,  332,  333,
  334,  335,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  302,  303,  304,  260,  306,  307,  308,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
  319,  320,  321,  322,  323,  324,   -1,  326,  327,  328,
   -1,   -1,  331,  332,  333,  334,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  302,  303,
  304,  260,  306,  307,  308,  309,  310,  311,  312,  313,
  314,  315,  316,  317,  318,  319,  320,  321,  322,  323,
  324,   -1,  326,  327,  328,   -1,   -1,  331,  332,  333,
  334,  335,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  302,  303,  304,   -1,  306,  307,  308,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
  319,  320,  321,  322,  323,  324,   -1,  326,  327,  328,
   -1,   -1,  331,  332,  333,  334,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,  345,  346,  260,   -1,
   -1,   -1,   -1,   -1,   -1,  267,  268,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
  302,  303,  304,   -1,  306,  307,  308,  309,  310,  311,
  312,   -1,   -1,   -1,  316,  317,  318,  319,  320,  321,
  322,  323,  324,   -1,  326,  327,  328,   -1,   -1,  331,
  332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  260,   -1,   -1,   -1,   -1,
   -1,   -1,  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  302,  303,  304,
   -1,  306,  307,  308,  309,  310,  311,  312,   -1,   -1,
   -1,  316,  317,  318,  319,  320,  321,  322,  323,  324,
   -1,  326,  327,  328,   -1,   -1,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  260,   -1,   -1,   -1,   -1,   -1,   -1,  267,
  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  302,  303,  304,   -1,  306,  307,
  308,  309,  310,  311,  312,   -1,   -1,   -1,  316,  317,
  318,  319,  320,  321,  322,  323,  324,   -1,  326,  327,
  328,   -1,   -1,  331,  332,  333,  334,  335,  336,  337,
  338,  339,  340,  341,  342,  343,  344,  345,  346,  260,
   -1,   -1,   -1,   -1,   -1,   -1,  267,  268,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  302,  303,  304,   -1,  306,  307,  308,  309,  310,
  311,  312,   -1,   -1,   -1,  316,  317,  318,  319,  320,
  321,  322,  323,  324,   -1,  326,  327,  328,   -1,   -1,
  331,  332,  333,  334,  335,  336,  337,  338,  339,  340,
  341,  342,  343,  344,  345,  346,  260,   -1,   -1,   -1,
   -1,   -1,   -1,  267,  268,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  302,  303,
  304,   -1,  306,  307,  308,  309,  310,  311,  312,   -1,
   -1,   -1,  316,  317,  318,  319,  320,  321,  322,  323,
  324,   -1,  326,  327,  328,   -1,   -1,  331,  332,  333,
  334,  335,  336,  337,  338,  339,  340,  341,  342,  343,
  344,  345,  346,  260,   -1,   -1,   -1,   -1,   -1,   -1,
  267,  268,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  302,  303,  304,  260,  306,
  307,  308,   -1,   -1,   -1,  267,  268,   -1,   -1,  316,
  317,  318,  319,  320,  321,  322,  323,  324,   -1,  326,
  327,  328,   -1,   -1,  331,  332,  333,  334,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  302,  303,  304,  260,  306,  307,  308,   -1,   -1,   -1,
  267,  268,   -1,   -1,  316,  317,  318,  319,  320,  321,
  322,  323,  324,   -1,  326,  327,  328,   -1,   -1,  331,
  332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  302,  303,  304,  260,  306,
  307,  308,   -1,   -1,   -1,  267,  268,   -1,   -1,  316,
  317,  318,  319,  320,  321,  322,  323,  324,   -1,  326,
  327,  328,   -1,   -1,  331,  332,  333,  334,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  302,  303,  304,  260,  306,  307,  308,   -1,   -1,   -1,
  267,  268,   -1,   -1,  316,  317,  318,   -1,   -1,  321,
  322,  323,  324,   -1,  326,  327,  328,   -1,   -1,  331,
  332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  302,  303,  304,  260,  306,
  307,  308,   -1,   -1,   -1,  267,  268,   -1,   -1,  316,
  317,  318,   -1,   -1,  321,  322,  323,  324,   -1,  326,
  327,  328,   -1,   -1,  331,  332,  333,  334,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  302,  303,  304,  260,  306,  307,  308,   -1,   -1,   -1,
  267,  268,   -1,   -1,  316,  317,  318,   -1,   -1,  321,
   -1,  323,  324,   -1,  326,  327,  328,   -1,   -1,  331,
  332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  302,  303,  304,  260,  306,
  307,  308,   -1,   -1,   -1,  267,  268,   -1,   -1,  316,
  317,  318,   -1,   -1,  321,   -1,  323,  324,   -1,  326,
  327,  328,   -1,   -1,  331,  332,  333,  334,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  302,  303,  304,  260,  306,  307,  308,   -1,   -1,   -1,
  267,  268,   -1,   -1,  316,  317,  318,   -1,   -1,  321,
   -1,  323,   -1,   -1,  326,  327,  328,   -1,   -1,  331,
  332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  302,  303,  304,  260,  306,
  307,  308,   -1,   -1,   -1,  267,  268,   -1,   -1,  316,
  317,  318,   -1,   -1,  321,   -1,  323,   -1,   -1,  326,
  327,  328,   -1,   -1,  331,  332,  333,  334,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  302,  303,  304,  260,  306,  307,  308,   -1,   -1,   -1,
  267,  268,   -1,   -1,  316,  317,  318,   -1,   -1,  321,
   -1,   -1,   -1,   -1,  326,  327,  328,   -1,   -1,  331,
  332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  302,  303,  304,  260,  306,
  307,  308,   -1,   -1,   -1,  267,  268,   -1,   -1,  316,
  317,  318,   -1,   -1,  321,   -1,   -1,   -1,   -1,  326,
  327,  328,   -1,   -1,  331,  332,  333,  334,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  302,  303,  304,  260,  306,  307,  308,   -1,   -1,   -1,
  267,  268,   -1,   -1,  316,   -1,  318,   -1,   -1,  321,
   -1,   -1,   -1,   -1,  326,  327,  328,   -1,   -1,  331,
  332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  302,  303,  304,  260,  306,
  307,  308,   -1,   -1,   -1,  267,  268,   -1,   -1,  316,
   -1,  318,   -1,   -1,  321,   -1,   -1,   -1,   -1,  326,
  327,  328,   -1,   -1,  331,  332,  333,  334,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  302,  303,  304,  260,  306,  307,  308,   -1,   -1,   -1,
  267,  268,   -1,   -1,  316,   -1,   -1,   -1,   -1,  321,
   -1,   -1,   -1,   -1,   -1,  327,  328,   -1,   -1,  331,
  332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  302,   -1,  304,  260,   -1,
  307,   -1,   -1,   -1,   -1,  267,  268,   -1,   -1,  316,
   -1,   -1,   -1,   -1,  321,   -1,   -1,   -1,   -1,   -1,
   -1,  328,   -1,   -1,  331,  332,  333,  334,  335,  336,
  337,  338,  339,  340,  341,  342,  343,  344,  345,  346,
  302,  303,  304,   -1,   -1,  307,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  316,   -1,   -1,   -1,   -1,  321,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  331,
  332,  333,  334,  335,  336,  337,  338,  339,  340,  341,
  342,  343,  344,  345,  346,  261,  262,  263,   -1,   -1,
  266,  267,  268,  269,  270,  271,  272,  273,  274,  275,
  276,  277,  278,  279,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  282,  283,  284,  285,  286,  287,  288,  289,
  290,  291,  292,  309,  310,  311,  312,  313,  314,  315,
   -1,  317,  318,  319,  320,   -1,  322,  323,  324,   -1,
  326,  260,  261,  262,   -1,   -1,   -1,  266,  267,  268,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,  328,  345,
  346,  331,  332,  333,  334,  335,  336,  337,  338,  339,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  302,  303,  304,   -1,  306,  307,  308,
  309,  310,  311,  312,  313,  314,  315,  316,  317,  318,
  319,  320,  321,  322,  323,  324,  257,  326,  327,  328,
   -1,   -1,  331,  332,  333,  334,  335,  336,  337,  338,
  339,  340,  341,  342,  343,  344,   -1,   -1,   -1,   -1,
   -1,  282,  283,  284,  285,  286,  287,  288,  289,  290,
  291,  292,  293,  294,  295,  296,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  304,   -1,   -1,   -1,   -1,  309,   -1,
   -1,   -1,   -1,   -1,  257,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,  328,  329,   -1,
  331,  332,  333,  334,  335,  336,  337,  338,  339,  282,
  283,  284,  285,  286,  287,  288,  289,  290,  291,  292,
  293,  294,  295,  296,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,  267,  268,   -1,   -1,  309,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,  328,  329,   -1,  331,  332,
  333,  334,  335,  336,  337,  338,  339,  302,   -1,   -1,
   -1,   -1,  307,   -1,   -1,   -1,   -1,  267,  268,   -1,
   -1,  316,   -1,   -1,   -1,   -1,  321,   -1,   -1,   -1,
   -1,   -1,   -1,  328,   -1,   -1,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  302,   -1,   -1,   -1,   -1,  307,   -1,   -1,
   -1,   -1,  267,  268,   -1,   -1,  316,   -1,   -1,   -1,
   -1,  321,   -1,   -1,   -1,   -1,   -1,   -1,  328,   -1,
   -1,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  302,   -1,   -1,
   -1,  306,  307,   -1,   -1,   -1,   -1,  267,  268,   -1,
   -1,  316,   -1,   -1,   -1,   -1,  321,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  340,  341,  342,  343,  344,
  345,  346,  302,   -1,   -1,   -1,   -1,  307,   -1,   -1,
   -1,   -1,   -1,   -1,   -1,   -1,  316,   -1,   -1,   -1,
   -1,  321,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,  331,  332,  333,  334,  335,  336,  337,  338,  339,
  340,  341,  342,  343,  344,  345,  346,  282,  283,  284,
  285,  286,  287,  288,  289,  290,  291,  292,  293,  294,
  295,  296,   -1,   -1,   -1,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,   -1,  309,   -1,   -1,   -1,  282,  283,
  284,  285,  286,  287,  288,  289,  290,  291,  292,  293,
  294,  295,  296,  328,  329,   -1,  331,  332,  333,  334,
  335,  336,  337,  338,  339,  309,   -1,   -1,   -1,   -1,
  282,  283,  284,  285,  286,  287,  288,  289,  290,  291,
  292,   -1,   -1,   -1,  328,  329,   -1,  331,  332,  333,
  334,  335,  336,  337,  338,  339,  308,   -1,   -1,  302,
   -1,   -1,   -1,   -1,  307,   -1,   -1,   -1,   -1,   -1,
   -1,   -1,   -1,  316,   -1,   -1,  328,   -1,  321,  331,
  332,  333,  334,  335,  336,  337,  338,  339,  331,  332,
  333,  334,  335,  336,  337,  338,  339,  340,  341,  342,
  343,  344,
};
}
final static short YYFINAL=1;
final static short YYMAXTOKEN=346;
final static String yyname[] = {
"end-of-file",null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,null,
null,null,null,"SEMI","DOT","DOTDOTDOT","COMMA","STAR","PERCENT","EQUALS",
"ANNOSTRING","ANNOCHAR","SLASH","PLUS","MINUS","STAREQUALS","SLASHEQUALS",
"PERCENTEQUALS","PLUSEQUALS","MINUSEQUALS","LESSTHAN2EQUALS",
"GREATERTHAN2EQUALS","GREATERTHAN3EQUALS","AMPERSANDEQUALS","CIRCUMFLEXEQUALS",
"VERTLINEEQUALS","PACKAGE","IMPORT","PUBLIC","PROTECTED","PRIVATE","STATIC",
"FINAL","ABSTRACT","NATIVE","STRICTFP","SYNCHRONIZED","TRANSIENT","VOLATILE",
"CLASS","INTERFACE","ENUM","ANNOINTERFACE","THROWS","EXTENDS","IMPLEMENTS",
"SUPER","DEFAULT","NEW","BRACEOPEN","BRACECLOSE","SQUAREOPEN","SQUARECLOSE",
"PARENOPEN","PARENCLOSE","LESSTHAN","GREATERTHAN","LESSEQUALS","GREATEREQUALS",
"LESSTHAN2","GREATERTHAN2","GREATERTHAN3","EXCLAMATION","AMPERSAND2",
"VERTLINE2","EQUALS2","NOTEQUALS","TILDE","AMPERSAND","VERTLINE","CIRCUMFLEX",
"VOID","QUERY","COLON","AT","CODEBLOCK","PARENBLOCK","BYTE","SHORT","INT",
"LONG","CHAR","FLOAT","DOUBLE","BOOLEAN","IDENTIFIER","BOOLEAN_LITERAL",
"INTEGER_LITERAL","FLOAT_LITERAL","CHAR_LITERAL","STRING_LITERAL","PLUSPLUS",
"MINUSMINUS",
};
final static String yyrule[] = {
"$accept : CompilationUnit",
"CompilationUnit : PackageDeclaration_opt ImportDeclarations_opt TypeDeclarations_opt",
"PackageDeclaration : package",
"PackageDeclaration : Annotation",
"PackageDeclaration_opt :",
"PackageDeclaration_opt : PackageDeclaration_opt PackageDeclaration",
"$$1 :",
"package : PACKAGE $$1 QualifiedIdentifier SEMI",
"ImportDeclaration : SingleTypeImportDeclaration",
"ImportDeclaration : TypeImportOnDemandDeclaration",
"ImportDeclaration : SingleStaticImportDeclaration",
"ImportDeclaration : StaticImportOnDemandDeclaration",
"ImportDeclarations_opt :",
"ImportDeclarations_opt : ImportDeclarations_opt ImportDeclaration",
"SingleTypeImportDeclaration : IMPORT QualifiedIdentifier SEMI",
"TypeImportOnDemandDeclaration : IMPORT QualifiedIdentifier DOT STAR SEMI",
"SingleStaticImportDeclaration : IMPORT STATIC QualifiedIdentifier SEMI",
"StaticImportOnDemandDeclaration : IMPORT STATIC QualifiedIdentifier DOT STAR SEMI",
"TypeDeclarations_opt :",
"$$2 :",
"TypeDeclarations_opt : TypeDeclarations_opt $$2 TypeDeclaration",
"TypeDeclaration : ClassOrInterfaceDeclaration",
"TypeDeclaration : SEMI",
"ClassOrInterfaceDeclaration : Modifiers_opt ClassDeclaration",
"ClassOrInterfaceDeclaration : Modifiers_opt InterfaceDeclaration",
"ClassDeclaration : NormalClassDeclaration",
"ClassDeclaration : EnumDeclaration",
"InterfaceDeclaration : NormalInterfaceDeclaration",
"InterfaceDeclaration : AnnotationTypeDeclaration",
"$$3 :",
"NormalClassDeclaration : CLASS IDENTIFIER TypeParameters_opt _ExtendsType_opt _ImplementsTypeList_opt $$3 ClassBody",
"$$4 :",
"EnumDeclaration : ENUM IDENTIFIER _ImplementsTypeList_opt $$4 EnumBody",
"$$5 :",
"NormalInterfaceDeclaration : INTERFACE IDENTIFIER TypeParameters_opt _ExtendsTypelist_opt $$5 ClassBody",
"$$6 :",
"AnnotationTypeDeclaration : ANNOINTERFACE IDENTIFIER $$6 ClassBody",
"_ExtendsType_opt :",
"_ExtendsType_opt : EXTENDS ReferenceType",
"_ExtendsTypelist_opt :",
"_ExtendsTypelist_opt : EXTENDS TypeList",
"_ImplementsTypeList_opt :",
"_ImplementsTypeList_opt : IMPLEMENTS TypeList",
"QualifiedIdentifier : IDENTIFIER",
"QualifiedIdentifier : QualifiedIdentifier DOT IDENTIFIER",
"Type : BasicType Dims_opt",
"Type : ReferenceType Dims_opt",
"BasicType : BYTE",
"BasicType : SHORT",
"BasicType : CHAR",
"BasicType : INT",
"BasicType : LONG",
"BasicType : FLOAT",
"BasicType : DOUBLE",
"BasicType : BOOLEAN",
"ReferenceType : ClassOrInterfaceType",
"$$7 :",
"ClassOrInterfaceType : TypeDeclSpecifier $$7 TypeArguments_opt",
"TypeDeclSpecifier : QualifiedIdentifier",
"TypeDeclSpecifier : ClassOrInterfaceType DOT IDENTIFIER",
"$$8 :",
"TypeArguments : LESSTHAN $$8 _TypeArgumentList GREATERTHAN",
"TypeArguments_opt :",
"TypeArguments_opt : TypeArguments",
"TypeArgument : ReferenceType Dims_opt",
"TypeArgument : QUERY",
"TypeArgument : QUERY EXTENDS Type",
"TypeArgument : QUERY SUPER Type",
"_TypeArgumentList : TypeArgument",
"_TypeArgumentList : _TypeArgumentList COMMA TypeArgument",
"NonWildcardTypeArguments : LESSTHAN TypeList GREATERTHAN",
"TypeList : ReferenceType",
"TypeList : TypeList COMMA ReferenceType",
"TypeArgumentsOrDiamond_opt :",
"TypeArgumentsOrDiamond_opt : LESSTHAN GREATERTHAN",
"TypeArgumentsOrDiamond_opt : TypeArguments",
"$$9 :",
"TypeParameters : LESSTHAN $$9 TypeParameterList GREATERTHAN",
"TypeParameters_opt :",
"TypeParameters_opt : TypeParameters",
"TypeParameterList : TypeParameter",
"TypeParameterList : TypeParameterList COMMA TypeParameter",
"$$10 :",
"TypeParameter : IDENTIFIER $$10 _ExtendsBound_opt",
"Bound : ReferenceType",
"Bound : Bound AMPERSAND ReferenceType",
"_ExtendsBound_opt :",
"$$11 :",
"_ExtendsBound_opt : EXTENDS $$11 Bound",
"Modifiers_opt :",
"Modifiers_opt : Modifiers_opt Modifier",
"Modifier : Annotation",
"Modifier : PUBLIC",
"Modifier : PROTECTED",
"Modifier : PRIVATE",
"Modifier : STATIC",
"Modifier : FINAL",
"Modifier : ABSTRACT",
"Modifier : NATIVE",
"Modifier : SYNCHRONIZED",
"Modifier : VOLATILE",
"Modifier : TRANSIENT",
"Modifier : STRICTFP",
"Annotations_opt :",
"Annotations_opt : Annotations_opt Annotation",
"$$12 :",
"Annotation : AT QualifiedIdentifier $$12 _AnnotationParens_opt",
"AnnotationElement_opt :",
"AnnotationElement_opt : ElementValuePairs",
"AnnotationElement_opt : ElementValue",
"ElementValuePairs : ElementValuePair",
"ElementValuePairs : ElementValuePairs COMMA ElementValuePair",
"ElementValuePair : IDENTIFIER EQUALS ElementValue",
"ElementValue : ConditionalExpression",
"ElementValue : Annotation",
"ElementValue : ElementValueArrayInitializer",
"$$13 :",
"ElementValueArrayInitializer : $$13 BRACEOPEN ElementValues_opt BRACECLOSE",
"ElementValues_opt :",
"ElementValues_opt : ElementValues_opt ElementValue",
"ElementValues_opt : ElementValues_opt COMMA",
"_AnnotationParens_opt :",
"_AnnotationParens_opt : PARENOPEN AnnotationElement_opt PARENCLOSE",
"ClassBody : BRACEOPEN ClassBodyDeclarations_opt BRACECLOSE",
"ClassBody_opt :",
"ClassBody_opt : ClassBody",
"ClassBodyDeclaration : SEMI",
"ClassBodyDeclaration : Modifiers_opt MemberDecl",
"ClassBodyDeclaration : StaticInitializer",
"ClassBodyDeclarations_opt :",
"$$14 :",
"ClassBodyDeclarations_opt : ClassBodyDeclarations_opt $$14 ClassBodyDeclaration",
"ConstructorDeclaration : constructor",
"StaticInitializer : static_block",
"MemberDecl : FieldDeclaration",
"MemberDecl : MethodDeclaration",
"MemberDecl : ConstructorDeclaration",
"MemberDecl : ClassDeclaration",
"MemberDecl : InterfaceDeclaration",
"static_block : Modifiers_opt CODEBLOCK",
"$$15 :",
"FieldDeclaration : Type VariableDeclaratorId $$15 extrafields SEMI",
"extrafields :",
"$$16 :",
"extrafields : extrafields COMMA $$16 VariableDeclaratorId",
"VariableDeclaratorId : IDENTIFIER Dims_opt",
"MethodDeclaration : MethodHeader _MemberEnd",
"$$17 :",
"MethodHeader : TypeParameters Type IDENTIFIER $$17 FormalParameters Dims_opt Throws_opt",
"$$18 :",
"MethodHeader : Type IDENTIFIER $$18 FormalParameters Dims_opt Throws_opt",
"FormalParameters : PARENOPEN FormalParameterDecls_opts PARENCLOSE",
"$$19 :",
"FormalParameterDecls : Modifiers_opt Type $$19 FormalParameterDeclsRest",
"FormalParameterDecls_opts :",
"FormalParameterDecls_opts : FormalParameterDecls",
"FormalParameterDeclsRest : VariableDeclaratorId",
"$$20 :",
"FormalParameterDeclsRest : VariableDeclaratorId $$20 COMMA FormalParameterDecls",
"FormalParameterDeclsRest : DOTDOTDOT VariableDeclaratorId",
"Throws_opt :",
"Throws_opt : THROWS ExceptionTypeList",
"ExceptionTypeList : ClassOrInterfaceType",
"ExceptionTypeList : ExceptionTypeList COMMA ClassOrInterfaceType",
"_MemberEnd : CODEBLOCK",
"_MemberEnd : SEMI",
"$$21 :",
"constructor : IDENTIFIER $$21 FormalParameters Throws_opt _MemberEnd",
"$$22 :",
"constructor : TypeParameters IDENTIFIER $$22 FormalParameters Throws_opt CODEBLOCK",
"Arguments_opt :",
"Arguments_opt : PARENOPEN ArgumentList_opt PARENCLOSE",
"VariableInitializer : ArrayInitializer",
"VariableInitializer : Expression",
"ArrayInitializer : BRACEOPEN VariableInitializers_opt BRACECLOSE",
"VariableInitializers_opt :",
"VariableInitializers_opt : VariableInitializers_opt VariableInitializer",
"VariableInitializers_opt : VariableInitializers_opt COMMA",
"Primary : Literal",
"Primary : PARENOPEN Expression PARENCLOSE",
"Primary : BasicType Dims_opt DOT CLASS",
"Primary : QualifiedIdentifier DOT CLASS",
"Primary : QualifiedIdentifier Dims DOT CLASS",
"Primary : QualifiedIdentifier",
"Primary : MethodInvocation",
"Primary : NEW Creator",
"Literal : INTEGER_LITERAL",
"Literal : FLOAT_LITERAL",
"Literal : CHAR_LITERAL",
"Literal : STRING_LITERAL",
"Literal : BOOLEAN_LITERAL",
"Arguments : PARENOPEN ExpressionList_opt PARENCLOSE",
"Creator : NonWildcardTypeArguments CreatedName ClassCreatorRest",
"Creator : CreatedName ClassCreatorRest",
"Creator : CreatedName ArrayCreatorRest",
"CreatedName : IDENTIFIER TypeArgumentsOrDiamond_opt",
"CreatedName : CreatedName DOT IDENTIFIER TypeArgumentsOrDiamond_opt",
"ClassCreatorRest : Arguments ClassBody_opt",
"ArrayCreatorRest : Dims ArrayInitializer",
"ArrayCreatorRest : DimExprs Dims_opt",
"ArgumentList : Expression",
"ArgumentList : ArgumentList COMMA Expression",
"ArgumentList_opt :",
"ArgumentList_opt : ArgumentList",
"DimExprs : DimExpr",
"DimExprs : DimExprs DimExpr",
"DimExpr : SQUAREOPEN Expression SQUARECLOSE",
"Dims : SQUAREOPEN SQUARECLOSE",
"Dims : Dims SQUAREOPEN SQUARECLOSE",
"Dims_opt :",
"Dims_opt : Dims",
"MethodInvocation : IDENTIFIER PARENOPEN ArgumentList_opt PARENCLOSE",
"MethodInvocation : QualifiedIdentifier DOT TypeParameters_opt IDENTIFIER PARENOPEN ArgumentList_opt PARENCLOSE",
"PostfixExpression : Primary",
"PostfixExpression : PostfixExpression PLUSPLUS",
"PostfixExpression : PostfixExpression MINUSMINUS",
"UnaryExpression : PLUSPLUS UnaryExpression",
"UnaryExpression : MINUSMINUS UnaryExpression",
"UnaryExpression : PLUS UnaryExpression",
"UnaryExpression : MINUS UnaryExpression",
"UnaryExpression : UnaryExpressionNotPlusMinus",
"UnaryExpressionNotPlusMinus : PostfixExpression",
"UnaryExpressionNotPlusMinus : TILDE UnaryExpression",
"UnaryExpressionNotPlusMinus : EXCLAMATION UnaryExpression",
"UnaryExpressionNotPlusMinus : CastExpression",
"CastExpression : PARENOPEN BasicType Dims_opt PARENCLOSE UnaryExpression",
"CastExpression : PARENOPEN QualifiedIdentifier PARENCLOSE UnaryExpressionNotPlusMinus",
"CastExpression : PARENOPEN QualifiedIdentifier Dims PARENCLOSE UnaryExpressionNotPlusMinus",
"MultiplicativeExpression : UnaryExpression",
"MultiplicativeExpression : MultiplicativeExpression STAR UnaryExpression",
"MultiplicativeExpression : MultiplicativeExpression SLASH UnaryExpression",
"MultiplicativeExpression : MultiplicativeExpression PERCENT UnaryExpression",
"AdditiveExpression : MultiplicativeExpression",
"AdditiveExpression : AdditiveExpression PLUS MultiplicativeExpression",
"AdditiveExpression : AdditiveExpression MINUS MultiplicativeExpression",
"ShiftExpression : AdditiveExpression",
"ShiftExpression : ShiftExpression LESSTHAN2 AdditiveExpression",
"ShiftExpression : ShiftExpression GREATERTHAN3 AdditiveExpression",
"ShiftExpression : ShiftExpression GREATERTHAN2 AdditiveExpression",
"RelationalExpression : ShiftExpression",
"RelationalExpression : RelationalExpression LESSEQUALS ShiftExpression",
"RelationalExpression : RelationalExpression GREATEREQUALS ShiftExpression",
"RelationalExpression : RelationalExpression LESSTHAN ShiftExpression",
"RelationalExpression : RelationalExpression GREATERTHAN ShiftExpression",
"EqualityExpression : RelationalExpression",
"EqualityExpression : EqualityExpression EQUALS2 RelationalExpression",
"EqualityExpression : EqualityExpression NOTEQUALS RelationalExpression",
"InclusiveOrExpression : ExclusiveOrExpression",
"InclusiveOrExpression : InclusiveOrExpression VERTLINE ExclusiveOrExpression",
"ExclusiveOrExpression : AndExpression",
"ExclusiveOrExpression : ExclusiveOrExpression CIRCUMFLEX AndExpression",
"AndExpression : EqualityExpression",
"AndExpression : AndExpression AMPERSAND EqualityExpression",
"ConditionalAndExpression : InclusiveOrExpression",
"ConditionalAndExpression : ConditionalAndExpression AMPERSAND2 InclusiveOrExpression",
"ConditionalOrExpression : ConditionalAndExpression",
"ConditionalOrExpression : ConditionalOrExpression VERTLINE2 ConditionalAndExpression",
"ConditionalExpression : ConditionalOrExpression",
"ConditionalExpression : ConditionalOrExpression QUERY Expression COLON ConditionalExpression",
"AssignmentExpression : ConditionalExpression",
"AssignmentExpression : Assignment",
"Assignment : LeftHandSide AssignmentOperator AssignmentExpression",
"LeftHandSide : QualifiedIdentifier",
"AssignmentOperator : EQUALS",
"AssignmentOperator : PLUSEQUALS",
"AssignmentOperator : MINUSEQUALS",
"AssignmentOperator : STAREQUALS",
"AssignmentOperator : SLASHEQUALS",
"AssignmentOperator : AMPERSANDEQUALS",
"AssignmentOperator : VERTLINEEQUALS",
"AssignmentOperator : CIRCUMFLEXEQUALS",
"AssignmentOperator : PERCENTEQUALS",
"AssignmentOperator : LESSTHAN2EQUALS",
"AssignmentOperator : GREATERTHAN2EQUALS",
"AssignmentOperator : GREATERTHAN3EQUALS",
"Expression : AssignmentExpression",
"ExpressionList_opt :",
"ExpressionList_opt : ExpressionList",
"ExpressionList : Expression",
"ExpressionList : ExpressionList Expression",
"EnumBody : BRACEOPEN EnumConstants_opt EnumBodyDeclarations_opt BRACECLOSE",
"EnumConstants_opt :",
"EnumConstants_opt : EnumConstants_opt COMMA",
"EnumConstants_opt : EnumConstants_opt EnumConstant",
"$$23 :",
"EnumConstant : Annotations_opt IDENTIFIER $$23 Arguments_opt ClassBody_opt",
"EnumBodyDeclarations_opt :",
"EnumBodyDeclarations_opt : SEMI ClassBodyDeclarations_opt",
};

//#line 1235 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"

private JavaLexer lexer;
private Builder builder;
private StringBuilder textBuffer = new StringBuilder();
private ClassDef cls = new ClassDef();
private MethodDef mth = new MethodDef();
private FieldDef fd;
private List<TypeVariableDef> typeParams = new LinkedList<TypeVariableDef>(); //for both JavaClass and JavaMethod
private LinkedList<AnnoDef> annotationStack = new LinkedList<AnnoDef>(); // Use LinkedList instead of Stack because it is unsynchronized 
private List<List<ElemValueDef>> annoValueListStack = new LinkedList<List<ElemValueDef>>(); // Use LinkedList instead of Stack because it is unsynchronized
private List<ElemValueDef> annoValueList = null;
private FieldDef param = new FieldDef();
private java.util.Set<String> modifiers = new java.util.LinkedHashSet<String>();
private TypeDef fieldType;
private TypeVariableDef typeVariable;
private Stack<TypeDef> typeStack = new Stack<TypeDef>();
private List<TypeDef> typeList = new LinkedList<TypeDef>();
private int line;
private int column;
private boolean debugLexer;

private void appendToBuffer(String word) {
    if (textBuffer.length() > 0) {
        char lastChar = textBuffer.charAt(textBuffer.length() - 1);
        if (!Character.isWhitespace(lastChar)) {
            textBuffer.append(' ');
        }
    }
    textBuffer.append(word);
}

private String buffer() {
    String result = textBuffer.toString().trim();
    textBuffer.setLength(0);
    return result;
}

public Parser( JavaLexer lexer, Builder builder ) 
{
    lexer.addCommentHandler( this );
    this.lexer = lexer;
    this.builder = builder;
}

public void setDebugParser(boolean debug) {
    yydebug = debug;
}

public void setDebugLexer(boolean debug) {
    debugLexer = debug;
}

/**
 * Parse file. Return true if successful.
 */
public boolean parse() {
    return yyparse() == 0;
}

private int yylex() {
    try {
        final int result = lexer.lex();
        yylval = new Value();
        yylval.sval = lexer.text();
        if (debugLexer) {
            System.err.println("Token: " + yyname[result] + " \"" + yylval.sval + "\"");
        }
        return result;
    }
    catch(IOException e) {
        return 0;
    }
}

private void yyerror(String msg) {
    throw new ParseException(msg, lexer.getLine(), lexer.getColumn());
}

private class Value {
    Object oval;
    String sval;
    int ival;
    boolean bval;
    TypeDef type;
    ElemValueDef annoval;
}


private void makeField(TypeDef field, String body, boolean enumConstant) {
    fd = new FieldDef( field.getName() );
    fd.setName(field.getName());
    fd.setLineNumber(line);
    fd.getModifiers().addAll(modifiers); 
    fd.setType( fieldType );
    fd.setDimensions(field.getDimensions());
    fd.setEnumConstant(enumConstant);
    fd.setBody(body);
}

public void onComment( String comment, int line, int column ) {
  DefaultJavaCommentLexer commentLexer  = new DefaultJavaCommentLexer( new java.io.StringReader( comment ) );
  commentLexer.setLineOffset( line );
  commentLexer.setColumnOffset( column );
  DefaultJavaCommentParser commentParser = new DefaultJavaCommentParser( commentLexer, builder);
  commentParser.setDebugLexer( this.debugLexer );
  commentParser.setDebugParser( this.yydebug );
  commentParser.parse();
}
//#line 1563 "Parser.java"
//###############################################################
// method: yylexdebug : check lexer state
//###############################################################
void yylexdebug(int state,int ch)
{
String s=null;
  if (ch < 0) ch=0;
  if (ch <= YYMAXTOKEN) //check index bounds
     s = yyname[ch];    //now get it
  if (s==null)
    s = "illegal-symbol";
  debug("state "+state+", reading "+ch+" ("+s+")");
}





//The following are now global, to aid in error reporting
int yyn;       //next next thing to do
int yym;       //
int yystate;   //current parsing state from state table
String yys;    //current token string


//###############################################################
// method: yyparse : parse input and execute indicated items
//###############################################################
int yyparse()
{
boolean doaction;
  init_stacks();
  yynerrs = 0;
  yyerrflag = 0;
  yychar = -1;          //impossible char forces a read
  yystate=0;            //initial state
  state_push(yystate);  //save it
  val_push(yylval);     //save empty value
  while (true) //until parsing is done, either correctly, or w/error
    {
    doaction=true;
    if (yydebug) debug("loop"); 
    //#### NEXT ACTION (from reduction table)
    for (yyn=yydefred[yystate];yyn==0;yyn=yydefred[yystate])
      {
      if (yydebug) debug("yyn:"+yyn+"  state:"+yystate+"  yychar:"+yychar);
      if (yychar < 0)      //we want a char?
        {
        yychar = yylex();  //get next token
        if (yydebug) debug(" next yychar:"+yychar);
        //#### ERROR CHECK ####
        if (yychar < 0)    //it it didn't work/error
          {
          yychar = 0;      //change it to default string (no -1!)
          if (yydebug)
            yylexdebug(yystate,yychar);
          }
        }//yychar<0
      yyn = yysindex[yystate];  //get amount to shift by (shift index)
      if ((yyn != 0) && (yyn += yychar) >= 0 &&
          yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
        {
        if (yydebug)
          debug("state "+yystate+", shifting to state "+yytable[yyn]);
        //#### NEXT STATE ####
        yystate = yytable[yyn];//we are in a new state
        state_push(yystate);   //save it
        val_push(yylval);      //push our lval as the input for next rule
        yychar = -1;           //since we have 'eaten' a token, say we need another
        if (yyerrflag > 0)     //have we recovered an error?
           --yyerrflag;        //give ourselves credit
        doaction=false;        //but don't process yet
        break;   //quit the yyn=0 loop
        }

    yyn = yyrindex[yystate];  //reduce
    if ((yyn !=0 ) && (yyn += yychar) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yychar)
      {   //we reduced!
      if (yydebug) debug("reduce");
      yyn = yytable[yyn];
      doaction=true; //get ready to execute
      break;         //drop down to actions
      }
    else //ERROR RECOVERY
      {
      if (yyerrflag==0)
        {
        yyerror("syntax error");
        yynerrs++;
        }
      if (yyerrflag < 3) //low error count?
        {
        yyerrflag = 3;
        while (true)   //do until break
          {
          if (stateptr<0)   //check for under & overflow here
            {
            yyerror("stack underflow. aborting...");  //note lower case 's'
            return 1;
            }
          yyn = yysindex[state_peek(0)];
          if ((yyn != 0) && (yyn += YYERRCODE) >= 0 &&
                    yyn <= YYTABLESIZE && yycheck[yyn] == YYERRCODE)
            {
            if (yydebug)
              debug("state "+state_peek(0)+", error recovery shifting to state "+yytable[yyn]+" ");
            yystate = yytable[yyn];
            state_push(yystate);
            val_push(yylval);
            doaction=false;
            break;
            }
          else
            {
            if (yydebug)
              debug("error recovery discarding state "+state_peek(0)+" ");
            if (stateptr<0)   //check for under & overflow here
              {
              yyerror("Stack underflow. aborting...");  //capital 'S'
              return 1;
              }
            state_pop();
            val_pop();
            }
          }
        }
      else            //discard this token
        {
        if (yychar == 0)
          return 1; //yyabort
        if (yydebug)
          {
          yys = null;
          if (yychar <= YYMAXTOKEN) yys = yyname[yychar];
          if (yys == null) yys = "illegal-symbol";
          debug("state "+yystate+", error recovery discards token "+yychar+" ("+yys+")");
          }
        yychar = -1;  //read another
        }
      }//end error recovery
    }//yyn=0 loop
    if (!doaction)   //any reason not to proceed?
      continue;      //skip action
    yym = yylen[yyn];          //get count of terminals on rhs
    if (yydebug)
      debug("state "+yystate+", reducing "+yym+" by rule "+yyn+" ("+yyrule[yyn]+")");
    if (yym>0)                 //if count of rhs not 'nil'
      yyval = val_peek(yym-1); //get current semantic value
    yyval = dup_yyval(yyval); //duplicate yyval if ParserVal is used as semantic value
    switch(yyn)
      {
//########## USER-SUPPLIED ACTIONS ##########
case 6:
//#line 85 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
           line = lexer.getLine(); 
         }
break;
case 7:
//#line 89 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
           builder.addPackage(new PackageDef(val_peek(1).sval, line)); 
         }
break;
case 14:
//#line 106 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                               builder.addImport( val_peek(1).sval ); 
                             }
break;
case 15:
//#line 111 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                                 builder.addImport( val_peek(3).sval + ".*" ); 
                               }
break;
case 16:
//#line 116 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                                 builder.addImport( "static " + val_peek(1).sval);
                               }
break;
case 17:
//#line 121 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                                   builder.addImport( "static " + val_peek(3).sval + ".*" ); 
                                 }
break;
case 19:
//#line 128 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                        line = lexer.getLine(); 
                      }
break;
case 29:
//#line 164 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                          cls.setType(ClassDef.CLASS);
                          cls.setLineNumber(line);
                          cls.getModifiers().addAll(modifiers); modifiers.clear(); 
                          cls.setName( val_peek(3).sval );
                          cls.setTypeParameters(typeParams);
                          builder.beginClass(cls); 
                          cls = new ClassDef(); 
                        }
break;
case 30:
//#line 174 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                          builder.endClass(); 
                        }
break;
case 31:
//#line 182 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                   cls.setLineNumber(line);
                   cls.getModifiers().addAll(modifiers);
                   cls.setName( val_peek(1).sval );
                   cls.setType(ClassDef.ENUM);
                   builder.beginClass(cls);
                   cls = new ClassDef();
                   fieldType = new TypeDef(val_peek(1).sval, 0);
                 }
break;
case 33:
//#line 197 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                              cls.setType(ClassDef.INTERFACE);
                              cls.setLineNumber(line);
                              cls.getModifiers().addAll(modifiers); modifiers.clear(); 
                              cls.setName( val_peek(2).sval );
                              cls.setTypeParameters(typeParams);
                              builder.beginClass(cls); 
                              cls = new ClassDef(); 
                            }
break;
case 34:
//#line 207 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                              builder.endClass(); 
                            }
break;
case 35:
//#line 215 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                             cls.setType(ClassDef.ANNOTATION_TYPE);
                             cls.setLineNumber(line);
                             cls.getModifiers().addAll(modifiers); modifiers.clear(); 
                             cls.setName( val_peek(0).sval );
                             builder.beginClass(cls); 
                             cls = new ClassDef();
                           }
break;
case 36:
//#line 224 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                             builder.endClass(); 
                           }
break;
case 38:
//#line 231 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                    cls.getExtends().add(val_peek(0).type);
                  }
break;
case 40:
//#line 238 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                        cls.getExtends().addAll( typeList );
                        typeList.clear();
                      }
break;
case 42:
//#line 246 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                           cls.getImplements().addAll( typeList );
                         }
break;
case 44:
//#line 255 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                       yyval.sval = val_peek(2).sval + '.' + val_peek(0).sval;
                     }
break;
case 45:
//#line 264 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
        TypeDef td = val_peek(1).type;
        td.setDimensions(val_peek(0).ival);
        yyval.type = td;
      }
break;
case 46:
//#line 270 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
        TypeDef td = val_peek(1).type;
        td.setDimensions(val_peek(0).ival);
        yyval.type = td;
      }
break;
case 47:
//#line 287 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
             yyval.type = new TypeDef("byte"); 
           }
break;
case 48:
//#line 291 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
             yyval.type = new TypeDef("short"); 
           }
break;
case 49:
//#line 295 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
             yyval.type = new TypeDef("char");
           }
break;
case 50:
//#line 299 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
             yyval.type = new TypeDef("int"); 
           }
break;
case 51:
//#line 303 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
             yyval.type = new TypeDef("long"); 
           }
break;
case 52:
//#line 307 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
             yyval.type = new TypeDef("float");
           }
break;
case 53:
//#line 311 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
             yyval.type = new TypeDef("double");
           }
break;
case 54:
//#line 315 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
             yyval.type = new TypeDef("boolean"); 
           }
break;
case 56:
//#line 331 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                        TypeDef td = new TypeDef(val_peek(0).sval,0);
                        yyval.type = typeStack.push(td);
                      }
break;
case 57:
//#line 336 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                        yyval.type = typeStack.pop();
                      }
break;
case 59:
//#line 344 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                     yyval.sval = val_peek(2).type.getName() + '.' + val_peek(0).sval;
                   }
break;
case 60:
//#line 352 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                 typeStack.peek().setActualArgumentTypes(new LinkedList<TypeDef>());
               }
break;
case 64:
//#line 365 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                TypeDef td = val_peek(1).type;
                td.setDimensions(val_peek(0).ival);
                yyval.type = td;
              }
break;
case 65:
//#line 371 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                yyval.type = new WildcardTypeDef(); 
              }
break;
case 66:
//#line 375 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                yyval.type = new WildcardTypeDef(val_peek(0).type, "extends" ); 
              }
break;
case 67:
//#line 379 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                yyval.type = new WildcardTypeDef(val_peek(0).type, "super" ); 
              }
break;
case 68:
//#line 385 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                    (typeStack.peek()).getActualArgumentTypes().add(val_peek(0).type);
                  }
break;
case 69:
//#line 389 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                    (typeStack.peek()).getActualArgumentTypes().add(val_peek(0).type);
                  }
break;
case 71:
//#line 403 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
            typeList.add( val_peek(0).type );
          }
break;
case 72:
//#line 407 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
            typeList.add( val_peek(0).type );
          }
break;
case 76:
//#line 427 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                  typeParams = new LinkedList<TypeVariableDef>(); 
                }
break;
case 82:
//#line 444 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                 typeVariable = new TypeVariableDef(val_peek(0).sval);
                 typeVariable.setBounds(new LinkedList<TypeDef>());
               }
break;
case 83:
//#line 449 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                 typeParams.add(typeVariable);
                 typeVariable = null;
               }
break;
case 84:
//#line 457 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
         typeVariable.getBounds().add(val_peek(0).type);
       }
break;
case 85:
//#line 461 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
         typeVariable.getBounds().add(val_peek(0).type);
       }
break;
case 87:
//#line 468 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                    typeVariable.setBounds(new LinkedList<TypeDef>());
                  }
break;
case 92:
//#line 492 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
            modifiers.add("public");
          }
break;
case 93:
//#line 496 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
            modifiers.add("protected");
          }
break;
case 94:
//#line 500 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
            modifiers.add("private");
          }
break;
case 95:
//#line 504 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
            modifiers.add("static");
          }
break;
case 96:
//#line 508 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
            modifiers.add("final");
          }
break;
case 97:
//#line 512 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
            modifiers.add("abstract");
          }
break;
case 98:
//#line 516 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
            modifiers.add("native");
          }
break;
case 99:
//#line 520 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
            modifiers.add("synchronized");
          }
break;
case 100:
//#line 524 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
            modifiers.add("volatile");
          }
break;
case 101:
//#line 528 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
            modifiers.add("transient");
          }
break;
case 102:
//#line 532 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
            modifiers.add("strictfp");
          }
break;
case 105:
//#line 543 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
           AnnoDef annotation = new AnnoDef( new TypeDef(val_peek(0).sval) );
           annotation.setLineNumber(lexer.getLine());
           annotationStack.addFirst(annotation);
         }
break;
case 106:
//#line 549 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
           AnnoDef annotation = annotationStack.removeFirst();
           if(annotationStack.isEmpty()) 
           {
             builder.addAnnotation(annotation);
           }
           yyval.annoval = annotation;
         }
break;
case 109:
//#line 564 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                         annotationStack.getFirst().getArgs().put("value", val_peek(0).annoval);
                       }
break;
case 112:
//#line 578 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                    annotationStack.getFirst().getArgs().put(val_peek(2).sval, val_peek(0).annoval);
                  }
break;
case 116:
//#line 595 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                                annoValueListStack.add(annoValueList);
                                annoValueList = new LinkedList<ElemValueDef>();
                              }
break;
case 117:
//#line 600 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                                yyval.annoval = new ElemValueListDef(annoValueList);
                                annoValueList = annoValueListStack.remove(annoValueListStack.size() - 1);
                              }
break;
case 119:
//#line 607 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                     annoValueList.add(val_peek(0).annoval); 
                   }
break;
case 130:
//#line 637 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                             line = lexer.getLine(); 
                           }
break;
case 139:
//#line 661 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                InitDef def = new InitDef();
                def.setStatic(modifiers.contains("static"));
                def.setBlockContent(lexer.getCodeBody());
                builder.addInitializer(def);
                modifiers.clear(); 
              }
break;
case 140:
//#line 672 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                    fieldType = val_peek(1).type;
                    makeField(val_peek(0).type, lexer.getCodeBody(), false);
                    builder.beginField(fd);
                    builder.endField();
                  }
break;
case 141:
//#line 679 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                    modifiers.clear();
                  }
break;
case 143:
//#line 685 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
               line = lexer.getLine();
             }
break;
case 144:
//#line 689 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
               makeField(val_peek(0).type, lexer.getCodeBody(), false);
               builder.beginField(fd);
               builder.endField();
             }
break;
case 145:
//#line 698 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                        yyval.type = new TypeDef(val_peek(1).sval,val_peek(0).ival);
                      }
break;
case 146:
//#line 705 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                     mth.setBody(val_peek(0).sval);
                     builder.endMethod(mth);
                     mth = new MethodDef();
                   }
break;
case 147:
//#line 712 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                builder.beginMethod();
                mth.setLineNumber(lexer.getLine());
                mth.getModifiers().addAll(modifiers); modifiers.clear();
                mth.setTypeParams(typeParams);
                mth.setReturnType(val_peek(1).type);
                mth.setName(val_peek(0).sval);
              }
break;
case 148:
//#line 721 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                mth.setDimensions(val_peek(1).ival);
              }
break;
case 149:
//#line 725 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                builder.beginMethod();
                mth.setLineNumber(lexer.getLine());
                mth.getModifiers().addAll(modifiers); modifiers.clear();
                mth.setReturnType(val_peek(1).type);
                mth.setName(val_peek(0).sval);
              }
break;
case 150:
//#line 733 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                mth.setDimensions(val_peek(1).ival);
              }
break;
case 152:
//#line 744 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                        param.setType(val_peek(0).type);
                        param.setVarArgs(false);
                        param.getModifiers().addAll(modifiers); modifiers.clear();
                      }
break;
case 156:
//#line 759 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
	                        param.setName(val_peek(0).type.getName());
                            param.setDimensions(val_peek(0).type.getDimensions());
                            builder.addParameter(param);
                            param = new FieldDef();
                          }
break;
case 157:
//#line 766 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
	                        param.setName(val_peek(0).type.getName());
                            param.setDimensions(val_peek(0).type.getDimensions());
                            builder.addParameter(param);
                            param = new FieldDef();
                          }
break;
case 159:
//#line 774 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                            param.setVarArgs(true);
	                        param.setName(val_peek(0).type.getName());
                            param.setDimensions(val_peek(0).type.getDimensions());
                            builder.addParameter(param);
                            param = new FieldDef();
                          }
break;
case 162:
//#line 788 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                     mth.getExceptions().add(val_peek(0).type); 
                   }
break;
case 163:
//#line 792 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                     mth.getExceptions().add(val_peek(0).type);
                   }
break;
case 164:
//#line 799 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
          yyval.sval = lexer.getCodeBody();
           }
break;
case 165:
//#line 803 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
             yyval.sval = "";
           }
break;
case 166:
//#line 810 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
               builder.beginConstructor();
               mth.setLineNumber(lexer.getLine());
               mth.getModifiers().addAll(modifiers); modifiers.clear();
               mth.setConstructor(true); 
               mth.setName(val_peek(0).sval);
             }
break;
case 167:
//#line 818 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
               mth.setBody(val_peek(0).sval);
               builder.endConstructor(mth);
               mth = new MethodDef(); 
             }
break;
case 168:
//#line 824 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
               builder.beginConstructor();
               mth.setLineNumber(lexer.getLine());
               mth.setTypeParams(typeParams);
               mth.getModifiers().addAll(modifiers); modifiers.clear();
               mth.setConstructor(true); 
               mth.setName(val_peek(0).sval);
             }
break;
case 169:
//#line 833 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
               mth.setBody(lexer.getCodeBody());
               builder.endConstructor(mth);
               mth = new MethodDef(); 
             }
break;
case 179:
//#line 875 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
           yyval.annoval = new ParenExpressionDef(val_peek(1).annoval); 
         }
break;
case 180:
//#line 879 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
           yyval.annoval = new TypeRefDef(new TypeDef(val_peek(3).type.getName(), val_peek(2).ival));
         }
break;
case 181:
//#line 883 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
            yyval.annoval = new TypeRefDef(new TypeDef(val_peek(2).sval, 0));
         }
break;
case 182:
//#line 887 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
           yyval.annoval = new TypeRefDef(new TypeDef(val_peek(3).sval, val_peek(2).ival));
         }
break;
case 183:
//#line 891 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
           yyval.annoval = new FieldRefDef(val_peek(0).sval); 
         }
break;
case 184:
//#line 895 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
           yyval.annoval = val_peek(0).annoval;
         }
break;
case 185:
//#line 899 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
           yyval.annoval = val_peek(0).annoval;
         }
break;
case 186:
//#line 912 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
           yyval.annoval = new ConstantDef(val_peek(0).sval, Integer.class); 
         }
break;
case 187:
//#line 916 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
           yyval.annoval = new ConstantDef(val_peek(0).sval, Float.class); 
         }
break;
case 188:
//#line 920 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
           String s = lexer.getCodeBody(); 
           yyval.annoval = new ConstantDef(s, Character.class); 
         }
break;
case 189:
//#line 925 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
           String s = lexer.getCodeBody(); 
           yyval.annoval = new ConstantDef(s, String.class); 
         }
break;
case 190:
//#line 930 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
           yyval.annoval = new ConstantDef(val_peek(0).sval, Boolean.class);
         }
break;
case 192:
//#line 946 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
           CreatorDef creator = new CreatorDef();
           creator.setCreatedName( val_peek(1).sval );
           yyval.annoval = creator; 
         }
break;
case 193:
//#line 952 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
           CreatorDef creator = new CreatorDef();
           creator.setCreatedName( val_peek(1).sval );
           yyval.annoval = creator; 
         }
break;
case 194:
//#line 958 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
           CreatorDef creator = new CreatorDef();
           creator.setCreatedName( val_peek(1).sval );
           yyval.annoval = creator; 
         }
break;
case 195:
//#line 968 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
               yyval.sval = val_peek(1).sval;
             }
break;
case 196:
//#line 972 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
               yyval.sval = val_peek(3).sval + "." + val_peek(1).sval;
             }
break;
case 200:
//#line 989 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                builder.addArgument( (ExpressionDef) val_peek(0).annoval);
              }
break;
case 201:
//#line 993 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                builder.addArgument( (ExpressionDef) val_peek(0).annoval);
              }
break;
case 207:
//#line 1006 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
        yyval.ival = 1;
      }
break;
case 208:
//#line 1010 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
        yyval.ival = val_peek(2).ival + 1;
      }
break;
case 209:
//#line 1013 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
            yyval.ival = 0; 
          }
break;
case 211:
//#line 1020 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                    yyval.annoval = new MethodInvocationDef(val_peek(3).sval, null);
                  }
break;
case 212:
//#line 1024 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                    yyval.annoval = new MethodInvocationDef(val_peek(6).sval, null);
                  }
break;
case 214:
//#line 1031 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new PostIncrementDef(val_peek(1).annoval); }
break;
case 215:
//#line 1032 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new PostDecrementDef(val_peek(1).annoval); }
break;
case 216:
//#line 1035 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new PreIncrementDef(val_peek(0).annoval);  }
break;
case 217:
//#line 1036 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new PreDecrementDef(val_peek(0).annoval);  }
break;
case 218:
//#line 1037 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new PlusSignDef(val_peek(0).annoval); }
break;
case 219:
//#line 1038 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new MinusSignDef(val_peek(0).annoval); }
break;
case 222:
//#line 1042 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new NotDef(val_peek(0).annoval); }
break;
case 223:
//#line 1043 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new LogicalNotDef(val_peek(0).annoval); }
break;
case 225:
//#line 1047 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new CastDef(new TypeDef(val_peek(3).type.getName(), val_peek(2).ival), val_peek(0).annoval); }
break;
case 226:
//#line 1048 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new CastDef(new TypeDef(val_peek(2).sval, 0), val_peek(0).annoval); }
break;
case 227:
//#line 1049 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new CastDef(new TypeDef(val_peek(3).sval, val_peek(2).ival), val_peek(0).annoval); }
break;
case 229:
//#line 1053 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new MultiplyDef(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 230:
//#line 1054 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new DivideDef(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 231:
//#line 1055 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new RemainderDef(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 233:
//#line 1059 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new AddDef(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 234:
//#line 1060 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new SubtractDef(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 236:
//#line 1064 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new ShiftLeftDef(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 237:
//#line 1065 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new UnsignedShiftRightDef(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 238:
//#line 1066 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ yyval.annoval = new ShiftRightDef(val_peek(2).annoval, val_peek(0).annoval); }
break;
case 240:
//#line 1071 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                        yyval.annoval = new LessEqualsDef(val_peek(2).annoval, val_peek(0).annoval);
                      }
break;
case 241:
//#line 1075 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                        yyval.annoval = new GreaterEqualsDef(val_peek(2).annoval, val_peek(0).annoval); 
                      }
break;
case 242:
//#line 1079 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                        yyval.annoval = new LessThanDef(val_peek(2).annoval, val_peek(0).annoval); 
                      }
break;
case 243:
//#line 1083 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                        yyval.annoval = new GreaterThanDef(val_peek(2).annoval, val_peek(0).annoval); 
                      }
break;
case 245:
//#line 1090 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                      yyval.annoval = new EqualsDef(val_peek(2).annoval, val_peek(0).annoval);
                    }
break;
case 246:
//#line 1094 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                      yyval.annoval = new NotEqualsDef(val_peek(2).annoval, val_peek(0).annoval); 
                    }
break;
case 248:
//#line 1101 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                         yyval.annoval = new OrDef(val_peek(2).annoval, val_peek(0).annoval); 
                       }
break;
case 250:
//#line 1107 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                         yyval.annoval = new ExclusiveOrDef(val_peek(2).annoval, val_peek(0).annoval);
                       }
break;
case 252:
//#line 1113 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                 yyval.annoval = new AndDef(val_peek(2).annoval, val_peek(0).annoval); 
               }
break;
case 254:
//#line 1120 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                            yyval.annoval = new LogicalAndDef(val_peek(2).annoval, val_peek(0).annoval); 
                          }
break;
case 256:
//#line 1127 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                           yyval.annoval = new LogicalOrDef(val_peek(2).annoval, val_peek(0).annoval);
                         }
break;
case 258:
//#line 1134 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                         yyval.annoval = new QueryDef(val_peek(4).annoval, val_peek(2).annoval, val_peek(0).annoval);
                       }
break;
case 261:
//#line 1143 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
              yyval.annoval = new AssignmentDef(val_peek(2).annoval, val_peek(1).sval, val_peek(0).annoval);
            }
break;
case 262:
//#line 1150 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                yyval.annoval = new FieldRefDef(val_peek(0).sval);
              }
break;
case 280:
//#line 1199 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
            builder.endClass();
            fieldType = null;
            modifiers.clear();
          }
break;
case 284:
//#line 1217 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{ 
                makeField( new TypeDef(val_peek(0).sval, 0), "", true );
                builder.beginField( fd );
              }
break;
case 285:
//#line 1222 "E:\java-workspace\codehaus-qdox\qdox\target\checkout/src/grammar/parser.y"
{
                builder.endField();
              }
break;
//#line 2660 "Parser.java"
//########## END OF USER-SUPPLIED ACTIONS ##########
    }//switch
    //#### Now let's reduce... ####
    if (yydebug) debug("reduce");
    state_drop(yym);             //we just reduced yylen states
    yystate = state_peek(0);     //get new state
    val_drop(yym);               //corresponding value drop
    yym = yylhs[yyn];            //select next TERMINAL(on lhs)
    if (yystate == 0 && yym == 0)//done? 'rest' state and at first TERMINAL
      {
      if (yydebug) debug("After reduction, shifting from state 0 to state "+YYFINAL+"");
      yystate = YYFINAL;         //explicitly say we're done
      state_push(YYFINAL);       //and save it
      val_push(yyval);           //also save the semantic value of parsing
      if (yychar < 0)            //we want another character?
        {
        yychar = yylex();        //get next character
        if (yychar<0) yychar=0;  //clean, if necessary
        if (yydebug)
          yylexdebug(yystate,yychar);
        }
      if (yychar == 0)          //Good exit (if lex returns 0 ;-)
         break;                 //quit the loop--all DONE
      }//if yystate
    else                        //else not done yet
      {                         //get next state and push, for next yydefred[]
      yyn = yygindex[yym];      //find out where to go
      if ((yyn != 0) && (yyn += yystate) >= 0 &&
            yyn <= YYTABLESIZE && yycheck[yyn] == yystate)
        yystate = yytable[yyn]; //get new state
      else
        yystate = yydgoto[yym]; //else go to new defred
      if (yydebug) debug("after reduction, shifting from state "+state_peek(0)+" to state "+yystate+"");
      state_push(yystate);     //going again, so push state & val...
      val_push(yyval);         //for next action
      }
    }//main loop
  return 0;//yyaccept!!
}
//## end of method parse() ######################################



//## run() --- for Thread #######################################
//## The -Jnorun option was used ##
//## end of method run() ########################################



//## Constructors ###############################################
//## The -Jnoconstruct option was used ##
//###############################################################



}
//################### END OF CLASS ##############################
